/*                        Copyright (c) 1987 Bellcore
 *                            All Rights Reserved
 *       Permission is granted to copy or use this program, EXCEPT that it
 *       may not be sold for profit, the copyright notice must be reproduced
 *       on copies, and credit should be given to Bellcore where it is due.
 *       BELLCORE MAKES NO WARRANTY AND ACCEPTS NO LIABILITY FOR THIS PROGRAM.
 */
/*	$Header: scribe.c,v 4.2 88/06/22 09:05:15 sau Exp $
	$Source: /tmp/mgrsrc/lib/RCS/scribe.c,v $
*/
static char	RCSid_[] = "$Source: /tmp/mgrsrc/lib/RCS/scribe.c,v $$Revision: 4.2 $";

/* These characters were adapted from the Hershey font collection.
 *
 *   The Hershey Fonts were originally created by Dr. A. V. Hershey
 *   while working at the U. S.  National Bureau of Standards.
 */

scribe( font, ch, min, max, npts, pts)
	int font, *npts;
	char ch;
	short	*min, *max, *pts;
#	define char_per_font 96
{
	int i;   char *c;
static char error_char[127] = { 62, -11, 11,
	    -2,4,0,4,0,5,-1,6,-2,5,-2,4,-2,2,-3,0,-2,-2,-3,-4,
	    -3,-7,-2,-9,0,-10,2,-9,3,-7,3,-4,2,-2,3,0,2,2,2,4,
	    2,5,1,6,0,5,0,4,2,4,31,31,-4,10,-5,5,-2,2,-3,1,-7,3,
	    -12,0,31,31,-10,-5,-7,0,-3,0,-3,-1,-6,-3,-5,-10,31,31,
	    4,10,5,5,2,2,3,1,7,3,12,0,31,31,10,-5,7,0,3,0,3,-1,
	    6,-3,5,-10,31,31,-2,-7,1,-7,2,-6,1,-5,-1,-5,-2,-4,
	    -1,-3,2,-3 };
static char c1[3] = {
	0,-8, 8	};			/*, 1, 45,  */
static char c2[31] = {
	14,-4, 6,			/*, 1, 54, !  */
	0, 12, -1, 10, 0, -2, 1, 10, 0, 12, 31, 31, 0, 10, 0, 4,
	31, 31, 0, -7, -1, -8, 0, -9, 1, -8, 0, -7 };
static char c3[25] = {
	11,-7, 9,			/*, 1, 61, "  */
	-3, 12, -4, 5, 31, 31, -2, 12, -4, 5, 31, 31, 3, 12, 2, 5,
	31, 31, 4, 12, 2, 5 };
static char c4[25] = {
	11,-10, 13,			/*, 1, 52, #  */
	1, 12, -6, -16, 31, 31, 7, 12, 0, -16, 31, 31, -6, 1, 8, 1,
	31, 31, -7, -5, 7, -5 };
static char c5[85] = {
	41,-10, 10,			/*, 1, 43, $  */
	-2, 16, -2, -13, 31, 31, 2, 16, 2, -13, 31, 31, 6, 9, 5, 8,
	6, 7, 7, 8, 7, 9, 5, 11, 2, 12, -2, 12, -5, 11, -7, 9,
	-7, 7, -6, 5, -5, 4, -3, 3, 3, 1, 5, 0, 7, -2, 31, 31,
	-7, 7, -5, 5, -3, 4, 3, 2, 5, 1, 6, 0, 7, -2, 7, -6,
	5, -8, 2, -9, -2, -9, -5, -8, -7, -6, -7, -5, -6, -4, -5, -5,
	-6, -6 };
static char c6[65] = {
	31,-12, 14,			/*, 1, 60, %  */
	9, 12, -9, -9, 31, 31, -4, 12, -2, 10, -2, 8, -3, 6, -5, 5,
	-7, 5, -9, 7, -9, 9, -8, 11, -6, 12, -4, 12, -2, 11, 1, 10,
	4, 10, 7, 11, 9, 12, 31, 31, 5, -2, 3, -3, 2, -5, 2, -7,
	4, -9, 6, -9, 8, -8, 9, -6, 9, -4, 7, -2, 5, -2 };
static char c7[99] = {
	48,-12, 15,			/*, 1, 55, &  */
	9, 4, 8, 3, 9, 2, 10, 3, 10, 4, 9, 5, 8, 5, 7, 4,
	6, 2, 4, -4, 3, -6, 1, -8, -1, -9, -5, -9, -8, -8, -9, -6,
	-9, -3, -8, -1, -2, 3, 0, 5, 1, 7, 1, 9, 0, 11, -2, 12,
	-4, 11, -5, 9, -5, 7, -4, 4, -2, 1, 3, -6, 5, -8, 8, -9,
	9, -9, 10, -8, 10, -7, 31, 31, -5, -9, -7, -8, -8, -6, -8, -3,
	-7, -1, -5, 1, 31, 31, -5, 7, -4, 5, 4, -6, 6, -8, 8, -9 };
static char c8[13] = {
	5,-4, 6,			/*, 1, 57, '  */
	0, 12, -1, 5, 31, 31, 1, 12, -1, 5 };
static char c9[41] = {
	19,-7, 7,			/*, 1, 41, (  */
	4, 16, 2, 14, 0, 11, -2, 7, -3, 2, -3, -2, -2, -7, 0, -11,
	2, -14, 4, -16, 31, 31, 2, 14, 0, 10, -1, 7, -2, 2, -2, -2,
	-1, -7, 0, -10, 2, -14 };
static char c10[41] = {
	19,-7, 7,			/*, 1, 42, )  */
	-4, 16, -2, 14, 0, 11, 2, 7, 3, 2, 3, -2, 2, -7, 0, -11,
	-2, -14, -4, -16, 31, 31, -2, 14, 0, 10, 1, 7, 2, 2, 2, -2,
	1, -7, 0, -10, -2, -14};
static char c11[19] = {
	8,-8, 8,			/*, 1, 39, *  */
	0, 12, 0, 0, 31, 31, -5, 9, 5, 3, 31, 31, 5, 9, -5, 3};
static char c12[13] = {
	5,-12, 12,			/*, 1, 37, +  */
	0, 9, 0, -9, 31, 31, -9, 0, 9, 0 };
static char c13[17] = {
	7,-4, 4,			/*, 1, 46, ,  */
	0, -9, -1, -8, 0, -7, 1, -8, 1, -10, 0, -12, -1, -13};
static char c14[7] = {
	2,-12, 12,			/*, 1, 38, -  */
	-9, 0, 9, 0 };
static char c15[13] = {
	5,-4, 4,			/*, 1, 47, .  */
	0, -7, -1, -8, 0, -9, 1, -8, 0, -7 };
static char c16[7] = {
	2,-11, 11,			/*, 1, 40, /  */
	9, 16, -9, -16 };
static char c17[81] = {
	39,-10, 12,			/*, 2, 27, 0, */
	-1, 12, -4, 11, -6, 8, -7, 3, -7, 0, -6, -5, -4, -8, -1, -9,
	1, -9, 4, -8, 6, -5, 7, 0, 7, 3, 6, 8, 4, 11, 1, 12,
	-1, 12, 31, 31, -1, 12, -3, 11, -4, 10, -5, 8, -6, 3, -6, 0,
	-5, -5, -4, -7, -3, -8, -1, -9, 31, 31, 1, -9, 3, -8, 4, -7,
	5, -5, 6, 0, 6, 3, 5, 8, 4, 10, 3, 11, 1, 12};
static char c18[23] = {
	10,-10, 12,			 /*, 2, 28, 1, */
	-4, 8, -2, 9, 1, 12, 1, -9, 31, 31, 0, 11, 0, -9, 31, 31,
	-4, -9, 5, -9};
static char c19[91] = {
	44,-10, 12,			/*, 2, 29, 2, */
	-6, 8, -5, 7, -6, 6, -7, 7, -7, 8, -6, 10, -5, 11, -2, 12,
	2, 12, 5, 11, 6, 10, 7, 8, 7, 6, 6, 4, 3, 2, -2, 0,
	-4, -1, -6, -3, -7, -6, -7, -9, 31, 31, 2, 12, 4, 11, 5, 10,
	6, 8, 6, 6, 5, 4, 2, 2, -2, 0, 31, 31, -7, -7, -6, -6,
	-4, -6, 1, -8, 4, -8, 6, -7, 7, -6, 31, 31, -4, -6, 1, -9,
	5, -9, 6, -8, 7, -6, 7, -4};
static char c20[93] = {
	45,-10, 12,			/*, 2, 30, 3, */
	-6, 9, -5, 8, -6, 7, -7, 8, -7, 9, -5, 11, -2, 12, 2, 12,
	5, 11, 6, 9, 6, 6, 5, 4, 2, 3, -1, 3, 31, 31, 2, 12,
	4, 11, 5, 9, 5, 6, 4, 4, 2, 3, 31, 31, 2, 3, 4, 2,
	6, 0, 7, -2, 7, -5, 6, -7, 5, -8, 2, -9, -2, -9, -5, -8,
	-6, -7, -7, -5, -7, -4, -6, -3, -5, -4, -6, -5, 31, 31, 5, 1,
	6, -2, 6, -5, 5, -7, 4, -8, 2, -9};
static char c21[27] = {
	12,-10, 12,			/*, 2, 31, 4, */
	2, 10, 2, -9, 31, 31, 3, 12, 3, -9, 31, 31, 3, 12, -8, -3,
	8, -3, 31, 31, -1, -9, 6, -9 };
static char c22[79] = {
	38,-10, 12,			/*, 2, 32, 5, */
	-5, 12, -7, 2, 31, 31, -7, 2, -5, 3, -2, 4, 1, 4, 4, 3,
	6, 1, 7, -2, 7, -3, 6, -6, 4, -8, 1, -9, -2, -9, -5, -8,
	-6, -7, -7, -5, -7, -4, -6, -3, -5, -4, -6, -5, 31, 31, 1, 4,
	3, 3, 5, 1, 6, -2, 6, -3, 5, -6, 3, -8, 1, -9, 31, 31,
	-5, 12, 5, 12, 31, 31, -5, 11, 0, 11, 5, 12 };
static char c23[97] = {
	47,-10, 12,			/*, 2, 33, 6, */
	5, 9, 4, 8, 5, 7, 6, 8, 6, 9, 5, 11, 3, 12, 0, 12,
	-3, 11, -5, 9, -6, 7, -7, 3, -7, -3, -6, -6, -4, -8, -1, -9,
	1, -9, 4, -8, 6, -6, 7, -3, 7, -2, 6, 1, 4, 3, 1, 4,
	0, 4, -3, 3, -5, 1, -6, -2, 31, 31, 0, 12, -2, 11, -4, 9,
	-5, 7, -6, 3, -6, -3, -5, -6, -3, -8, -1, -9, 31, 31, 1, -9,
	3, -8, 5, -6, 6, -3, 6, -2, 5, 1, 3, 3, 1, 4 };
static char c24[63] = {
	30,-10, 12,			/*, 2, 34, 7, */
	-7, 12, -7, 6, 31, 31, -7, 8, -6, 10, -4, 12, -2, 12, 3, 9,
	5, 9, 6, 10, 7, 12, 31, 31, -6, 10, -4, 11, -2, 11, 3, 9,
	31, 31, 7, 12, 7, 9, 6, 6, 2, 1, 1, -1, 0, -4, 0, -9,
	31, 31, 6, 6, 1, 1, 0, -1, -1, -4, -1, -9 };
static char c25[127] = {
	62,-10, 12,			/*, 2, 35, 8, */
	-2, 12, -5, 11, -6, 9, -6, 6, -5, 4, -2, 3, 2, 3, 5, 4,
	6, 6, 6, 9, 5, 11, 2, 12, -2, 12, 31, 31, -2, 12, -4, 11,
	-5, 9, -5, 6, -4, 4, -2, 3, 31, 31, 2, 3, 4, 4, 5, 6,
	5, 9, 4, 11, 2, 12, 31, 31, -2, 3, -5, 2, -6, 1, -7, -1,
	-7, -5, -6, -7, -5, -8, -2, -9, 2, -9, 5, -8, 6, -7, 7, -5,
	7, -1, 6, 1, 5, 2, 2, 3, 31, 31, -2, 3, -4, 2, -5, 1,
	-6, -1, -6, -5, -5, -7, -4, -8, -2, -9, 31, 31, 2, -9, 4, -8,
	5, -7, 6, -5, 6, -1, 5, 1, 4, 2, 2, 3 };
static char c26[97] = {
	47,-10, 12,			/*, 2, 36, 9, */
	6, 5, 5, 2, 3, 0, 0, -1, -1, -1, -4, 0, -6, 2, -7, 5,
	-7, 6, -6, 9, -4, 11, -1, 12, 1, 12, 4, 11, 6, 9, 7, 6,
	7, 0, 6, -4, 5, -6, 3, -8, 0, -9, -3, -9, -5, -8, -6, -6,
	-6, -5, -5, -4, -4, -5, -5, -6, 31, 31, -1, -1, -3, 0, -5, 2,
	-6, 5, -6, 6, -5, 9, -3, 11, -1, 12, 31, 31, 1, 12, 3, 11,
	5, 9, 6, 6, 6, 0, 5, -4, 4, -6, 2, -8, 0, -9 };
static char c27[25] = {
	11,-4, 6,			/*, 3, 63, ;  */
	0, 5, -1, 4, 0, 3, 1, 4, 0, 5, 31, 31, 0, -7, -1, -8,
	0, -9, 1, -8, 0, -7 };
static char c28[29] = {
	13,-4, 6,			/*, 1, 63, ;  */
	0, 5, -1, 4, 0, 3, 1, 4, 0, 5, 31, 31, 0, -9, -1, -8,
	0, -7, 1, -8, 1, -10, 0, -12, -1, -13 };
static char c29[9] = {
	3,-11, 13,			/*, 1, 58, <  */
	8, 9, -8, 0, 8, -9 };
static char c30[13] = {
	5,-12, 12,			/*, 1, 44, =  */
	-9, 3, 9, 3, 31, 31, -9, -3, 9, -3 };
static char c31[9] = {
	3,-11, 13,			/*, 1, 59, >  */
	-8, 9, 8, 0, -8, -9 };
static char c32[65] = {
	31,-9, 11,			/*, 1, 51, ?  */
	-5, 8, -4, 7, -5, 6, -6, 7, -6, 8, -5, 10, -4, 11, -2, 12,
	1, 12, 4, 11, 5, 10, 6, 8, 6, 6, 5, 4, 4, 3, 0, 1,
	0, -2, 31, 31, 1, 12, 3, 11, 4, 10, 5, 8, 5, 6, 4, 4,
	2, 2, 31, 31, 0, -7, -1, -8, 0, -9, 1, -8, 0, -7 };
static char c33[113] = {
	55,-13, 14,			/*, 9, 53, _  */
	5, 4, 4, 6, 2, 7, -1, 7, -3, 6, -4, 5, -5, 2, -5, -1,
	-4, -3, -2, -4, 1, -4, 3, -3, 4, -1, 31, 31, -1, 7, -3, 5,
	-4, 2, -4, -1, -3, -3, -2, -4, 31, 31, 5, 7, 4, -1, 4, -3,
	6, -4, 8, -4, 10, -2, 11, 1, 11, 3, 10, 6, 9, 8, 7, 10,
	5, 11, 2, 12, -1, 12, -4, 11, -6, 10, -8, 8, -9, 6, -10, 3,
	-10, 0, -9, -3, -8, -5, -6, -7, -4, -8, -1, -9, 2, -9, 5, -8,
	7, -7, 8, -6, 31, 31, 6, 7, 5, -1, 5, -3, 6, -4 };
static char c34[37] = {
	17,-10, 12,			/*, 2, 1, A  */
	0, 12, -7, -9, 31, 31, 0, 12, 7, -9, 31, 31, 0, 9, 6, -9,
	31, 31, -5, -4, 5, -4, 31, 31, -10, -9, -4, -9, 31, 31, 3, -9,
	10, -9 };
static char c35[91] = {
	44,-11, 13,			/*, 2, 2, B  */
	-6, 12, -6, -9, 31, 31, -5, 12, -5, -9, 31, 31, -9, 12, 3, 12,
	6, 11, 7, 10, 8, 8, 8, 6, 7, 4, 6, 3, 3, 2, 31, 31,
	3, 12, 5, 11, 6, 10, 7, 8, 7, 6, 6, 4, 5, 3, 3, 2,
	31, 31, -5, 2, 3, 2, 6, 1, 7, 0, 8, -2, 8, -5, 7, -7,
	6, -8, 3, -9, -9, -9, 31, 31, 3, 2, 5, 1, 6, 0, 7, -2,
	7, -5, 6, -7, 5, -8, 3, -9 };
static char c36[65] = {
	31,-11, 12,			/*, 2, 3, C  */
	6, 9, 7, 7, 7, 12, 6, 9, 4, 11, 1, 12, -1, 12, -4, 11,
	-6, 9, -7, 7, -8, 4, -8, -1, -7, -4, -6, -6, -4, -8, -1, -9,
	1, -9, 4, -8, 6, -6, 7, -4, 31, 31, -1, 12, -3, 11, -5, 9,
	-6, 7, -7, 4, -7, -1, -6, -4, -5, -6, -3, -8, -1, -9};
static char c37[61] = {
	29,-11, 13,			/*, 2, 4, D  */
	-6, 12, -6, -9, 31, 31, -5, 12, -5, -9, 31, 31, -9, 12, 1, 12,
	4, 11, 6, 9, 7, 7, 8, 4, 8, -1, 7, -4, 6, -6, 4, -8,
	1, -9, -9, -9, 31, 31, 1, 12, 3, 11, 5, 9, 6, 7, 7, 4,
	7, -1, 6, -4, 5, -6, 3, -8, 1, -9 };
static char c38[45] = {
	21,-11, 12,			/*, 2, 5, E  */
	-6, 12, -6, -9, 31, 31, -5, 12, -5, -9, 31, 31, 1, 6, 1, -2,
	31, 31, -9, 12, 7, 12, 7, 7, 6, 12, 31, 31, -5, 2, 1, 2,
	31, 31, -9, -9, 7, -9, 7, -4, 6, -9 };
static char c39[41] = {
	19,-11, 11,			/*, 2, 6, F  */
	-6, 12, -6, -9, 31, 31, -5, 12, -5, -9, 31, 31, 1, 6, 1, -2,
	31, 31, -9, 12, 7, 12, 7, 7, 6, 12, 31, 31, -5, 2, 1, 2,
	31, 31, -9, -9, -2, -9 };
static char c40[81] = {
	39,-11, 13,			/*, 2, 7, G  */
	6, 9, 7, 7, 7, 12, 6, 9, 4, 11, 1, 12, -1, 12, -4, 11,
	-6, 9, -7, 7, -8, 4, -8, -1, -7, -4, -6, -6, -4, -8, -1, -9,
	1, -9, 4, -8, 6, -6, 31, 31, -1, 12, -3, 11, -5, 9, -6, 7,
	-7, 4, -7, -1, -6, -4, -5, -6, -3, -8, -1, -9, 31, 31, 6, -1,
	6, -9, 31, 31, 7, -1, 7, -9, 31, 31, 3, -1, 9, -1 };
static char c41[55] = {
	26,-12, 14,			/*, 2, 8, H  */
	-7, 12, -7, -9, 31, 31, -6, 12, -6, -9, 31, 31, 6, 12, 6, -9,
	31, 31, 7, 12, 7, -9, 31, 31, -10, 12, -3, 12, 31, 31, 3, 12,
	10, 12, 31, 31, -6, 2, 6, 2, 31, 31, -10, -9, -3, -9, 31, 31,
	3, -9, 10, -9 };
static char c42[25] = {
	11,-5, 8,			/*, 2, 9, I  */
	0, 12, 0, -9, 31, 31, 1, 12, 1, -9, 31, 31, -3, 12, 4, 12,
	31, 31, -3, -9, 4, -9 };
static char c43[41] = {
	19,-8, 10,			/*, 2, 10, J  */
	3, 12, 3, -5, 2, -8, 0, -9, -2, -9, -4, -8, -5, -6, -5, -4,
	-4, -3, -3, -4, -4, -5, 31, 31, 2, 12, 2, -5, 1, -8, 0, -9,
	31, 31, -1, 12, 6, 12 };
static char c44[55] = {
	26,-12, 13,			/*, 2, 11, K  */
	-7, 12, -7, -9, 31, 31, -6, 12, -6, -9, 31, 31, 7, 12, -6, -1,
	31, 31, -1, 3, 7, -9, 31, 31, -2, 3, 6, -9, 31, 31, -10, 12,
	-3, 12, 31, 31, 4, 12, 10, 12, 31, 31, -10, -9, -3, -9, 31, 31,
	3, -9, 10, -9 };
static char c45[29] = {
	13,-10, 11,			/*, 2, 12, L  */
	-5, 12, -5, -9, 31, 31, -4, 12, -4, -9, 31, 31, -8, 12, -1, 12,
	31, 31, -8, -9, 7, -9, 7, -4, 6, -9 };
static char c46[61] = {
	29,-12, 15,			/*, 2, 13, M  */
	-7, 12, -7, -9, 31, 31, -6, 12, 0, -6, 31, 31, -7, 12, 0, -9,
	31, 31, 7, 12, 0, -9, 31, 31, 7, 12, 7, -9, 31, 31, 8, 12,
	8, -9, 31, 31, -10, 12, -6, 12, 31, 31, 7, 12, 11, 12, 31, 31,
	-10, -9, -4, -9, 31, 31, 4, -9, 11, -9 };
static char c47[43] = {
	20,-11, 14,			/*, 2, 14, N  */
	-6, 12, -6, -9, 31, 31, -5, 12, 7, -7, 31, 31, -5, 10, 7, -9,
	31, 31, 7, 12, 7, -9, 31, 31, -9, 12, -5, 12, 31, 31, 4, 12,
	10, 12, 31, 31, -9, -9, -3, -9 };
static char c48[89] = {
	43,-11, 13,			/*, 2, 15, O  */
	-1, 12, -4, 11, -6, 9, -7, 7, -8, 3, -8, 0, -7, -4, -6, -6,
	-4, -8, -1, -9, 1, -9, 4, -8, 6, -6, 7, -4, 8, 0, 8, 3,
	7, 7, 6, 9, 4, 11, 1, 12, -1, 12, 31, 31, -1, 12, -3, 11,
	-5, 9, -6, 7, -7, 3, -7, 0, -6, -4, -5, -6, -3, -8, -1, -9,
	31, 31, 1, -9, 3, -8, 5, -6, 6, -4, 7, 0, 7, 3, 6, 7, 
	5, 9, 3, 11, 1, 12 };
static char c49[59] = {
	28,-11, 13,			/*, 2, 16, P  */
	-6, 12, -6, -9, 31, 31, -5, 12, -5, -9, 31, 31, -9, 12, 3, 12,
	6, 11, 7, 10, 8, 8, 8, 5, 7, 3, 6, 2, 3, 1, -5, 1,
	31, 31, 3, 12, 5, 11, 6, 10, 7, 8, 7, 5, 6, 3, 5, 2,
	3, 1, 31, 31, -9, -9, -2, -9 };
static char c50[109] = {
	53,-11, 13,			/*, 2, 17, Q  */
	-1, 12, -4, 11, -6, 9, -7, 7, -8, 3, -8, 0, -7, -4, -6, -6,
	-4, -8, -1, -9, 1, -9, 4, -8, 6, -6, 7, -4, 8, 0, 8, 3,
	7, 7, 6, 9, 4, 11, 1, 12, -1, 12, 31, 31, -1, 12, -3, 11,
	-5, 9, -6, 7, -7, 3, -7, 0, -6, -4, -5, -6, -3, -8, -1, -9,
	31, 31, 1, -9, 3, -8, 5, -6, 6, -4, 7, 0, 7, 3, 6, 7,
	5, 9, 3, 11, 1, 12, 31, 31, -5, -6, -3, -4, -1, -4, 1, -5,
	2, -7, 3, -11, 4, -12, 5, -12, 6, -11 };
static char c51[79] = {
	38,-11, 13,			/*, 2, 18, R  */
	-6, 12, -6, -9, 31, 31, -5, 12, -5, -9, 31, 31, -9, 12, 3, 12,
	6, 11, 7, 10, 8, 8, 8, 6, 7, 4, 6, 3, 3, 2, -5, 2,
	31, 31, 3, 12, 5, 11, 6, 10, 7, 8, 7, 6, 6, 4, 5, 3,
	3, 2, 31, 31, -9, -9, -2, -9, 31, 31, 1, 2, 5, -7, 7, -9,
	9, -9, 10, -7, 31, 31, 1, 2, 3, 0, 7, -9 };
static char c52[69] = {
	33,-10, 12,			/*, 2, 19, S  */
	6, 10, 7, 12, 7, 8, 6, 10, 5, 11, 2, 12, -2, 12, -5, 11,
	-7, 9, -7, 7, -6, 5, -5, 4, -3, 3, 3, 1, 5, 0, 7, -2,
	31, 31, -7, 7, -5, 5, -3, 4, 3, 2, 5, 1, 6, 0, 7, -2,
	7, -6, 5, -8, 2, -9, -2, -9, -5, -8, -6, -7, -7, -5, -7, -9,
	-6, -7 };
static char c53[33] = {
	15,-9, 12,			/*, 2, 20, T  */
	0, 12, 0, -9, 31, 31, 1, 12, 1, -9, 31, 31, -6, 12, -7, 7,
	-7, 12, 8, 12, 8, 7, 7, 12, 31, 31, -3, -9, 4, -9 };
static char c54[47] = {
	22,-12, 14,			/*, 2, 21, U  */
	-7, 12, -7, -3, -6, -6, -4, -8, -1, -9, 1, -9, 4, -8, 6, -6,
	7, -3, 7, 12, 31, 31, -6, 12, -6, -3, -5, -6, -3, -8, -1, -9,
	31, 31, -10, 12, -3, 12, 31, 31, 4, 12, 10, 12 };
static char c55[31] = {
	14,-11, 13,			/*, 2, 22, V  */
	-7, 12, 0, -9, 31, 31, -6, 12, 0, -6, 31, 31, 7, 12, 0, -9,
	31, 31, -10, 12, -3, 12, 31, 31, 4, 12, 10, 12 };
static char c56[49] = {
	23,-12, 14,			/*, 2, 23, W  */
	-8, 12, -4, -9, 31, 31, -7, 12, -4, -4, 31, 31, 0, 12, -4, -9,
	31, 31, 0, 12, 4, -9, 31, 31, 1, 12, 4, -4, 31, 31, 8, 12,
	4, -9, 31, 31, -11, 12, -4, 12, 31, 31, 5, 12, 11, 12 };
static char c57[43] = {
	20,-11, 13,			/*, 2, 24, X  */
	-7, 12, 6, -9, 31, 31, -6, 12, 7, -9, 31, 31, 7, 12, -7, -9,
	31, 31, -10, 12, -3, 12, 31, 31, 4, 12, 10, 12, 31, 31, -10, -9,
	-4, -9, 31, 31, 3, -9, 10, -9 };
static char c58[41] = {
	19,-11, 14,			/*, 2, 25, Y  */
	-7, 12, 0, 1, 0, -9, 31, 31, -6, 12, 1, 1, 1, -9, 31, 31,
	8, 12, 1, 1, 31, 31, -10, 12, -3, 12, 31, 31, 5, 12, 11, 12,
	31, 31, -3, -9, 4, -9 };
static char c59[33] = {
	15,-10, 12,			/*, 2, 26, Z  */
	6, 12, -7, -9, 31, 31, 7, 12, -6, -9, 31, 31, -6, 12, -7, 7,
	-7, 12, 7, 12, 31, 31, -7, -9, 7, -9, 7, -4, 6, -9 };
static char c60[25] = {
	11,-7, 9,			/*, 1, 49, [  */
	-3, 16,-3,-16, 31, 31, -2, 16, -2, -16, 31, 31, -3, 16, 4, 16,
	31, 31, -3, -16, 4, -16 };
static char c61[7] = {
	2,-11, 11,			/*, 1, 40, /  */
	-9, 16, 9, -16 };
static char c62[25] = {
	11,-7, 9,			/*, 1, 50, ]  */
	2, 16, 2, -16, 31, 31, 3, 16, 3, -16, 31, 31, -4, 16, 3, 16,
	31, 31, -4, -16, 3, -16 };
static char c63[17] = {
	7,-11, 11,			/*, 9, 28, 1, */
	-8, -2, 0, 3, 8, -2, 31, 31, -8, -2, 0, 2, 8, -2 };
static char c64[7] = {
	2,-12, 12,			/*, 1, 38, -  */
	-9, -12, 9, -12 };
static char c65[15] = {
	6,-6, 6,			/*, 9, 30, 3, */
	-2, 12, 3, 6, 31, 31, -2, 12, -3, 11, 3, 6 };
static char c66[79] = {
	38,-9, 11,			/*, 1, 1, A  */
	-4, 3, -4, 2, -5, 2, -5, 3, -4, 4, -2, 5, 2, 5, 4, 4,
	5, 3, 6, 1, 6, -6, 7, -8, 8, -9, 31, 31, 5, 3, 5, -6,
	6, -8, 8, -9, 9, -9, 31, 31, 5, 1, 4, 0, -2, -1, -5, -2,
	-6, -4, -6, -6, -5, -8, -2, -9, 1, -9, 3, -8, 5, -6, 31, 31,
	-2, -1, -4, -2, -5, -4, -5, -6, -4, -8, -2, -9 };
static char c67[67] = {
	32,-11, 10,			/*, 1, 2, B  */
	-6, 12, -6, -9, 31, 31, -5, 12, -5, -9, 31, 31, -5, 2, -3, 4,
	-1, 5, 1, 5, 4, 4, 6, 2, 7, -1, 7, -3, 6, -6, 4, -8,
	1, -9, -1, -9, -3, -8, -5, -6, 31, 31, 1, 5, 3, 4, 5, 2,
	6, -1, 6, -3, 5, -6, 3, -8, 1, -9, 31, 31, -9, 12, -5, 12 };
static char c68[57] = {
	27,-10, 9,			/*, 1, 3, C  */
	5, 2, 4, 1, 5, 0, 6, 1, 6, 2, 4, 4, 2, 5, -1, 5,
	-4, 4, -6, 2, -7, -1, -7, -3, -6, -6, -4, -8, -1, -9, 1, -9,
	4, -8, 6, -6, 31, 31, -1, 5, -3, 4, -5, 2, -6, -1, -6, -3,
	-5, -6, -3, -8, -1, -9 };
static char c69[73] = {
	35,-10, 11,			/*, 1, 4, D  */
	5, 12, 5, -9, 31, 31, 6, 12, 6, -9, 31, 31, 5, 2, 3, 4,
	1, 5, -1, 5, -4, 4, -6, 2, -7, -1, -7, -3, -6, -6, -4, -8,
	-1, -9, 1, -9, 3, -8, 5, -6, 31, 31, -1, 5, -3, 4, -5, 2,
	-6, -1, -6, -3, -5, -6, -3, -8, -1, -9, 31, 31, 2, 12, 6, 12,
	31, 31, 5, -9, 9, -9 };
static char c70[63] = {
	30,-10, 9,			/*, 1, 5, E  */
	-6, -1, 6, -1, 6, 1, 5, 3, 4, 4, 2, 5, -1, 5, -4, 4,
	-6, 2, -7, -1, -7, -3, -6, -6, -4, -8, -1, -9, 1, -9, 4, -8,
	6, -6, 31, 31, 5, -1, 5, 2, 4, 4, 31, 31, -1, 5, -3, 4,
	-5, 2, -6, -1, -6, -3, -5, -6, -3, -8, -1, -9 };
static char c71[45] = {
	21,-7, 5,			/*, 1, 6, F  */
	3, 11, 2, 10, 3, 9, 4, 10, 4, 11, 3, 12, 1, 12, -1, 11,
	-2, 9, -2, -9, 31, 31, 1, 12, 0, 11, -1, 9, -1, -9, 31, 31,
	-5, 5, 2, 5, 31, 31, -5, -9, 2, -9 };
static char c72[121] = {
	59,-10, 10,			/*, 1, 7, G  */
	-1, 5, -3, 4, -4, 3, -5, 1, -5, -1, -4, -3, -3, -4, -1, -5,
	1, -5, 3, -4, 4, -3, 5, -1, 5, 1, 4, 3, 3, 4, 1, 5,
	-1, 5, 31, 31, -3, 4, -4, 2, -4, -2, -3, -4, 31, 31, 3, -4,
	4, -2, 4, 2, 3, 4, 31, 31, 4, 3, 5, 4, 7, 5, 7, 4,
	5, 4, 31, 31, -4, -3, -5, -4, -6, -6, -6, -7, -5, -9, -2, -10,
	3, -10, 6, -11, 7, -12, 31, 31, -6, -7, -5, -8, -2, -9, 3, -9,
	6,-10,7,-12,7, -13, 6, -15, 3, -16, -3, -16, -6, -15, -7, -13,
	-7, -12, -6, -10, -3, -9 };
static char c73[57] = {
	27,-11, 11,			/*, 1, 8, H  */
	-6, 12, -6, -9, 31, 31, -5, 12, -5, -9, 31, 31, -5, 2, -3, 4,
	0, 5, 2, 5, 5, 4, 6, 2, 6, -9, 31, 31, 2, 5, 4, 4,
	5, 2, 5, -9, 31, 31, -9, 12, -5, 12, 31, 31, -9, -9, -2, -9,
	31, 31, 2, -9, 9, -9 };
static char c74[37] = {
	17,-5, 6,			/*, 1, 9, I  */
	0, 12, -1, 11, 0, 10, 1, 11, 0, 12, 31, 31, 0, 5, 0, -9,
	31, 31, 1, 5, 1, -9, 31, 31, -3, 5, 1, 5, 31, 31, -3, -9,
	4, -9 };
static char c75[51] = {
	24,-5, 6,			/*, 1, 10, J  */
	1, 12, 0, 11, 1, 10, 2, 11, 1, 12, 31, 31, 2, 5, 2, -13,
	1, -15, -1, -16, -3, -16, -4, -15, -4, -14, -3, -13, -2, -14, -3, -15,
	31, 31, 1, 5, 1, -13, 0, -15, -1, -16, 31, 31, -2, 5, 2, 5 };
static char c76[55] = {
	26,-11, 11,			/*, 1, 11, K  */
	-6, 12, -6, -9, 31, 31, -5, 12, -5, -9, 31, 31, 5, 5, -5, -5,
	31, 31, 0, -1, 6, -9, 31, 31, -1, -1, 5, -9, 31, 31, -9, 12,
	-5, 12, 31, 31, 2, 5, 8, 5, 31, 31, -9, -9, -2, -9, 31, 31,
	2, -9, 9, -9 };
static char c77[25] = {
	11,-5, 6,			/*, 1, 12, L  */
	0, 12, 0, -9, 31, 31, 1, 12, 1, -9, 31, 31, -3, 12, 1, 12,
	31, 31, -3, -9, 4, -9 };
static char c78[89] = {
	43,-16, 17,			/*, 1, 13, M  */
	-11, 5, -11, -9, 31, 31, -10, 5, -10, -9, 31, 31, -10, 2, -8, 4,
	-5, 5, -3, 5, 0, 4, 1, 2, 1, -9, 31, 31, -3, 5, -1, 4,
	0, 2, 0, -9, 31, 31, 1, 2, 3, 4, 6, 5, 8, 5, 11, 4,
	12, 2, 12, -9, 31, 31, 8, 5, 10, 4, 11, 2, 11, -9, 31, 31,
	-14, 5, -10, 5, 31, 31, -14, -9, -7, -9, 31, 31, -3, -9, 4, -9,
	31, 31, 8, -9, 15, -9 };
static char c79[57] = {
	27,-11, 11,			/*, 1, 14, N  */
	-6, 5, -6, -9, 31, 31, -5, 5, -5, -9, 31, 31, -5, 2, -3, 4,
	0, 5, 2, 5, 5, 4, 6, 2, 6, -9, 31, 31, 2, 5, 4, 4,
	5, 2, 5, -9, 31, 31, -9, 5, -5, 5, 31, 31, -9, -9, -2, -9,
	31, 31, 2, -9, 9, -9 };
static char c80[73] = {
	35,-10, 10,			/*, 1, 15, O  */
	-1, 5, -4, 4, -6, 2, -7, -1, -7, -3, -6, -6, -4, -8, -1, -9,
	1, -9, 4, -8, 6, -6, 7, -3, 7, -1, 6, 2, 4, 4, 1, 5,
	-1, 5, 31, 31, -1, 5, -3, 4, -5, 2, -6, -1, -6, -3, -5, -6,
	-3, -8, -1, -9, 31, 31, 1, -9, 3, -8, 5, -6, 6, -3, 6, -1,
	5, 2, 3, 4, 1, 5 };
static char c81[73] = {
	35,-11, 10,			/*, 1, 16, P  */
	-6, 5, -6, -16, 31, 31, -5, 5, -5, -16, 31, 31, -5, 2, -3, 4,
	-1, 5, 1, 5, 4, 4, 6, 2, 7, -1, 7, -3, 6, -6, 4, -8,
	1, -9, -1, -9, -3, -8, -5, -6, 31, 31, 1, 5, 3, 4, 5, 2,
	6, -1, 6, -3, 5, -6, 3, -8, 1, -9, 31, 31, -9, 5, -5, 5,
	31, 31, -9, -16, -2, -16 };
static char c82[67] = {
	32,-10, 11,			/*, 1, 17, Q  */
	5, 5, 5, -16, 31, 31, 6, 5, 6, -16, 31, 31, 5, 2, 3, 4,
	1, 5, -1, 5, -4, 4, -6, 2, -7, -1, -7, -3, -6, -6, -4, -8,
	-1, -9, 1, -9, 3, -8, 5, -6, 31, 31, -1, 5, -3, 4, -5, 2,
	-6, -1, -6, -3, -5, -6, -3, -8, -1, -9, 31, 31, 2, -16, 9, -16 };
static char c83[47] = {
	22,-9, 8,			/*, 1, 18, R  */
	-4, 5, -4, -9, 31, 31, -3, 5, -3, -9, 31, 31, -3, -1, -2, 2,
	0, 4, 2, 5, 5, 5, 6, 4, 6, 3, 5, 2, 4, 3, 5, 4,
	31, 31, -7, 5, -3, 5, 31, 31, -7, -9, 0, -9 };
static char c84[61] = {
	29,-8, 9,			/*, 1, 19, S  */
	5, 4, 6, 5, 6, 2, 5, 4, 2, 5, -1, 5, -4, 4, -5, 3,
	-5, 2, -4, 0, -2, -1, 3, -3, 5, -4, 6, -5, 31, 31, -5, 2,
	-4, 1, -2, 0, 3, -2, 5, -3, 6, -5, 6, -7, 5, -8, 2, -9,
	-1, -9, -4, -8, -5, -6, -5, -9, -4, -8 };
static char c85[33] = {
	15,-7, 8,			/*, 1, 20, T  */
	-2, 12, -2, -5, -1, -8, 1, -9, 3, -9, 5, -8, 6, -6, 31, 31,
	-1, 12, -1, -5, 0, -8, 1, -9, 31, 31, -5, 5, 3, 5 };
static char c86[57] = {
	27,-11, 11,			/*, 1, 21, U  */
	-6, 5, -6, -6, -5, -8, -2, -9, 0, -9, 3, -8, 5, -6, 31, 31,
	-5, 5, -5, -6, -4, -8, -2, -9, 31, 31, 5, 5, 5, -9, 31, 31,
	6, 5, 6, -9, 31, 31, -9, 5, -5, 5, 31, 31, 2, 5, 6, 5,
	31, 31, 5, -9, 9, -9 };
static char c87[31] = {
	14,-10, 10,			/*, 1, 22, V  */
	-6, 5, 0, -9, 31, 31, -5, 5, 0, -7, 31, 31, 6, 5, 0, -9,
	31, 31, -9, 5, -2, 5, 31, 31, 3, 5, 9, 5 };
static char c88[49] = {
	23,-13, 13,			/*, 1, 23, W  */
	-8, 5, -4, -9, 31, 31, -7, 5, -4, -6, 31, 31, 0, 5, -4, -9,
	31, 31, 0, 5, 4, -9, 31, 31, 1, 5, 4, -6, 31, 31, 8, 5,
	4, -9, 31, 31, -11, 5, -4, 5, 31, 31, 5, 5, 11, 5 };
static char c89[43] = {
	20,-11, 11,			/*, 1, 24, X  */
	-6, 5, 5, -9, 31, 31, -5, 5, 6, -9, 31, 31, 6, 5, -6, -9,
	31, 31, -9, 5, -2, 5, 31, 31, 3, 5, 9, 5, 31, 31, -9, -9,
	-3, -9, 31, 31, 2, -9, 9, -9 };
static char c90[45] = {
	21,-10, 10,			/*, 1, 25, Y  */
	-6, 5, 0, -9, 31, 31, -5, 5, 0, -7, 31, 31, 6, 5, 0, -9,
	-2, -13, -4, -15, -6, -16, -7, -16, -8, -15, -7, -14, -6, -15, 31, 31,
	-9, 5, -2, 5, 31, 31, 3, 5, 9, 5 };
static char c91[33] = {
	15,-9, 9,			/*, 1, 26, Z  */
	5, 5, -6, -9, 31, 31, 6, 5, -5, -9, 31, 31, -5, 5, -6, 2,
	-6, 5, 6, 5, 31, 31, -6, -9, 6, -9, 6, -6, 5, -9 };
static char c92[57] = {
	27,-7, 9,			/*, 3, 49, [  */
	2, 16, -1, 13, -2, 10, -2, 8, -1, 5, 2, 2, 31, 31, 0, 14,
	-1, 11, -1, 7, 0, 4, 31, 31, 2, 2, -1, 0, 2, -2, 31, 31,
	2, -2, -1, -5, -2, -8, -2, -10, -1, -13, 2, -16, 31, 31, 0, -4,
	-1, -7, -1, -11, 0, -14 };
static char c93[7] = {
	2,-4, 4,			/*, 9, 14, N  */
	0, 16, 0, -16 };
static char c94[57] = {
	27,-7, 9,			/*, 3, 50, ]  */
	-2, 16, 1, 13, 2, 10, 2, 8, 1, 5, -2, 2, 31, 31, 0, 14,
	1, 11, 1, 7, 0, 4, 31, 31, -2, 2, 1, 0, -2, -2, 31, 31,
	-2, -2, 1, -5, 2, -8, 2, -10, 1, -13, -2, -16, 31, 31, 0, -4,
	1, -7, 1, -11, 0, -14 };
static char c95[49] = {
	23,-12, 14,			/*, 3, 59, >  */
	-9, -3, -9, -1, -8, 2, -6, 3, -4, 3, -2, 2, 2, -1, 4, -2,
	6, -2, 8, -1, 9, 1, 31, 31, -9, -1, -8, 1, -6, 2, -4, 2,
	-2, 1, 2, -2, 4, -3, 6, -3, 8, -2, 9, 1, 9, 3 };
static char c96[7] = {
	2,-12, 14,			/*, 3, 38, -  */
	-9, -12, 9, -12 };
static char c97[3] = {
	0,-8, 8	};			/*, 1, 45,  */
static char c98[31] = {
	14,-4, 6,			/*, 1, 54, !  */
	0, 12, -1, 10, 0, -2, 1, 10, 0, 12, 31, 31, 0, 10, 0, 4,
	31, 31, 0, -7, -1, -8, 0, -9, 1, -8, 0, -7 };
static char c99[25] = {
	11,-7, 9,			/*, 1, 61, "  */
	-3, 12, -4, 5, 31, 31, -2, 12, -4, 5, 31, 31, 3, 12, 2, 5,
	31, 31, 4, 12, 2, 5 };
static char c100[25] = {
	11,-10, 13,			/*, 1, 52, #  */
	1, 12, -6, -16, 31, 31, 7, 12, 0, -16, 31, 31, -6, 1, 8, 1,
	31, 31, -7, -5, 7, -5 };
static char c101[85] = {
	41,-10, 10,			/*, 1, 43, $  */
	-2, 16, -2, -13, 31, 31, 2, 16, 2, -13, 31, 31, 6, 9, 5, 8,
	6, 7, 7, 8, 7, 9, 5, 11, 2, 12, -2, 12, -5, 11, -7, 9,
	-7, 7, -6, 5, -5, 4, -3, 3, 3, 1, 5, 0, 7, -2, 31, 31,
	-7, 7, -5, 5, -3, 4, 3, 2, 5, 1, 6, 0, 7, -2, 7, -6,
	5, -8, 2, -9, -2, -9, -5, -8, -7, -6, -7, -5, -6, -4, -5, -5,
	-6, -6 };
static char c102[65] = {
	31,-12, 14,			/*, 1, 60, %  */
	9, 12, -9, -9, 31, 31, -4, 12, -2, 10, -2, 8, -3, 6, -5, 5,
	-7, 5, -9, 7, -9, 9, -8, 11, -6, 12, -4, 12, -2, 11, 1, 10,
	4, 10, 7, 11, 9, 12, 31, 31, 5, -2, 3, -3, 2, -5, 2, -7,
	4, -9, 6, -9, 8, -8, 9, -6, 9, -4, 7, -2, 5, -2 };
static char c103[99] = {
	48,-12, 15,			/*, 1, 55, &  */
	9, 4, 8, 3, 9, 2, 10, 3, 10, 4, 9, 5, 8, 5, 7, 4,
	6, 2, 4, -4, 3, -6, 1, -8, -1, -9, -5, -9, -8, -8, -9, -6,
	-9, -3, -8, -1, -2, 3, 0, 5, 1, 7, 1, 9, 0, 11, -2, 12,
	-4, 11, -5, 9, -5, 7, -4, 4, -2, 1, 3, -6, 5, -8, 8, -9,
	9, -9, 10, -8, 10, -7, 31, 31, -5, -9, -7, -8, -8, -6, -8, -3,
	-7, -1, -5, 1, 31, 31, -5, 7, -4, 5, 4, -6, 6, -8, 8, -9 };
static char c104[13] = {
	5,-4, 6,			/*, 1, 57, '  */
	0, 12, -1, 5, 31, 31, 1, 12, -1, 5 };
static char c105[41] = {
	19,-7, 7,			/*, 1, 41, (  */
	4, 16, 2, 14, 0, 11, -2, 7, -3, 2, -3, -2, -2, -7, 0, -11,
	2, -14, 4, -16, 31, 31, 2, 14, 0, 10, -1, 7, -2, 2, -2, -2,
	-1, -7, 0, -10, 2, -14 };
static char c106[41] = {
	19,-7, 7,			/*, 1, 42, )  */
	-4, 16, -2, 14, 0, 11, 2, 7, 3, 2, 3, -2, 2, -7, 0, -11,
	-2, -14, -4, -16, 31, 31, -2, 14, 0, 10, 1, 7, 2, 2, 2, -2,
	1, -7, 0, -10, -2, -14 };
static char c107[19] = {
	8,-8, 8,			/*, 1, 39, *  */
	0, 12, 0, 0, 31, 31, -5, 9, 5, 3, 31, 31, 5, 9, -5, 3 };
static char c108[13] = {
	5,-12, 12,			/*, 1, 37, +  */
	0, 9, 0, -9, 31, 31, -9, 0, 9, 0 };
static char c109[17] = {
	7,-4, 4,			/*, 1, 46, ,  */
	0, -9, -1, -8, 0, -7, 1, -8, 1, -10, 0, -12, -1, -13 };
static char c110[7] = {
	2,-12, 12,			/*, 1, 38, -  */
	-9, 0, 9, 0 };
static char c111[13] = {
	5,-4, 4,			/*, 1, 47, .  */
	0, -7, -1, -8, 0, -9, 1, -8, 0, -7 };
static char c112[7] = {
	2,-11, 11,			/*, 1, 40, /  */
	9, 16, -9, -16 };
static char c113[81] = {
	39,-10, 12,			/*, 2, 27, 0, */
	-1, 12, -4, 11, -6, 8, -7, 3, -7, 0, -6, -5, -4, -8, -1, -9,
	1, -9, 4, -8, 6, -5, 7, 0, 7, 3, 6, 8, 4, 11, 1, 12,
	-1, 12, 31, 31, -1, 12, -3, 11, -4, 10, -5, 8, -6, 3, -6, 0,
	-5, -5, -4, -7, -3, -8, -1, -9, 31, 31, 1, -9, 3, -8, 4, -7,
	5, -5, 6, 0, 6, 3, 5, 8, 4, 10, 3, 11, 1, 12 };
static char c114[23] = {
	10,-10, 12,			/*, 2, 28, 1, */
	-4, 8, -2, 9, 1, 12, 1, -9, 31, 31, 0, 11, 0, -9, 31, 31,
	-4, -9, 5, -9 };
static char c115[91] = {
	44,-10, 12,			/*, 2, 29, 2, */
	-6, 8, -5, 7, -6, 6, -7, 7, -7, 8, -6, 10, -5, 11, -2, 12,
	2, 12, 5, 11, 6, 10, 7, 8, 7, 6, 6, 4, 3, 2, -2, 0,
	-4, -1, -6, -3, -7, -6, -7, -9, 31, 31, 2, 12, 4, 11, 5, 10,
	6, 8, 6, 6, 5, 4, 2, 2, -2, 0, 31, 31, -7, -7, -6, -6,
	-4, -6, 1, -8, 4, -8, 6, -7, 7, -6, 31, 31, -4, -6, 1, -9,
	5, -9, 6, -8, 7, -6, 7, -4 };
static char c116[93] = {
	45,-10, 12,			/*, 2, 30, 3, */
	-6, 9, -5, 8, -6, 7, -7, 8, -7, 9, -5, 11, -2, 12, 2, 12,
	5, 11, 6, 9, 6, 6, 5, 4, 2, 3, -1, 3, 31, 31, 2, 12,
	4, 11, 5, 9, 5, 6, 4, 4, 2, 3, 31, 31, 2, 3, 4, 2,
	6, 0, 7, -2, 7, -5, 6, -7, 5, -8, 2, -9, -2, -9, -5, -8,	
	-6, -7, -7, -5, -7, -4, -6, -3, -5, -4, -6, -5, 31, 31, 5, 1,
	6, -2, 6, -5, 5, -7, 4, -8, 2, -9 };
static char c117[27] = {
	12,-10, 12,			/*, 2, 31, 4, */
	2, 10, 2, -9, 31, 31, 3, 12, 3, -9, 31, 31, 3, 12, -8, -3,
	8, -3, 31, 31, -1, -9, 6, -9 };
static char c118[79] = {
	38,-10, 12,			/*, 2, 32, 5, */
	-5, 12, -7, 2, 31, 31, -7, 2, -5, 3, -2, 4, 1, 4, 4, 3,
	6, 1, 7, -2, 7, -3, 6, -6, 4, -8, 1, -9, -2, -9, -5, -8,
	-6, -7, -7, -5, -7, -4, -6, -3, -5, -4, -6, -5, 31, 31, 1, 4,
	3, 3, 5, 1, 6, -2, 6, -3, 5, -6, 3, -8, 1, -9, 31, 31,
	-5, 12, 5, 12, 31, 31, -5, 11, 0, 11, 5, 12 };
static char c119[97] = {
	47,-10, 12,			/*, 2, 33, 6, */
	5, 9, 4, 8, 5, 7, 6, 8, 6, 9, 5, 11, 3, 12, 0, 12,
	-3, 11, -5, 9, -6, 7, -7, 3, -7, -3, -6, -6, -4, -8, -1, -9,
	1, -9, 4, -8, 6, -6, 7, -3, 7, -2, 6, 1, 4, 3, 1, 4,
	0, 4, -3, 3, -5, 1, -6, -2, 31, 31, 0, 12, -2, 11, -4, 9,
	-5, 7, -6, 3, -6, -3, -5, -6, -3, -8, -1, -9, 31, 31, 1, -9,
	3, -8, 5, -6, 6, -3, 6, -2, 5, 1, 3, 3, 1, 4 };
static char c120[63] = {
	30,-10, 12,			/*, 2, 34, 7, */
	-7, 12, -7, 6, 31, 31, -7, 8, -6, 10, -4, 12, -2, 12, 3, 9,
	5, 9, 6, 10, 7, 12, 31, 31, -6, 10, -4, 11, -2, 11, 3, 9,
	31, 31, 7, 12, 7, 9, 6, 6, 2, 1, 1, -1, 0, -4, 0, -9,
	31, 31, 6, 6, 1, 1, 0, -1, -1, -4, -1, -9 };
static char c121[127] = {
	62,-10, 12,			/*, 2, 35, 8, */
	-2, 12, -5, 11, -6, 9, -6, 6, -5, 4, -2, 3, 2, 3, 5, 4,
	6, 6, 6, 9, 5, 11, 2, 12, -2, 12, 31, 31, -2, 12, -4, 11,
	-5, 9, -5, 6, -4, 4, -2, 3, 31, 31, 2, 3, 4, 4, 5, 6,
	5, 9, 4, 11, 2, 12, 31, 31, -2, 3, -5, 2, -6, 1, -7, -1,
	-7, -5, -6, -7, -5, -8, -2, -9, 2, -9, 5, -8, 6, -7, 7, -5,	
	7, -1, 6, 1, 5, 2, 2, 3, 31, 31, -2, 3, -4, 2, -5, 1,
	-6, -1, -6, -5, -5, -7, -4, -8, -2, -9, 31, 31, 2, -9, 4, -8,
	5, -7, 6, -5, 6, -1, 5, 1, 4, 2, 2, 3 };
static char c122[97] = {
	47,-10, 12,			/*, 2, 36, 9, */
	6, 5, 5, 2, 3, 0, 0, -1, -1, -1, -4, 0, -6, 2, -7, 5,
	-7, 6, -6, 9, -4, 11, -1, 12, 1, 12, 4, 11, 6, 9, 7, 6,
	7, 0, 6, -4, 5, -6, 3, -8, 0, -9, -3, -9, -5, -8, -6, -6,
	-6, -5, -5, -4, -4, -5, -5, -6, 31, 31, -1, -1, -3, 0, -5, 2,
	-6, 5, -6, 6, -5, 9, -3, 11, -1, 12, 31, 31, 1, 12, 3, 11,
	5, 9, 6, 6, 6, 0, 5, -4, 4, -6, 2, -8, 0, -9 };
static char c123[25] = {
	11,-4, 6,			/*, 3, 63, ;  */
	0, 5, -1, 4, 0, 3, 1, 4, 0, 5, 31, 31, 0, -7, -1, -8,
	0, -9, 1, -8, 0, -7 };
static char c124[29] = {
	13,-4, 6,			/*, 1, 63, ;  */
	0, 5, -1, 4, 0, 3, 1, 4, 0, 5, 31, 31, 0, -9, -1, -8,
	0, -7, 1, -8, 1, -10, 0, -12, -1, -13 };
static char c125[9] = {
	3,-11, 13,			/*, 1, 58, <  */
	8, 9, -8, 0, 8, -9 };
static char c126[13] = {
	5,-12, 12,			/*, 1, 44, =  */
	-9, 3, 9, 3, 31, 31, -9, -3, 9, -3 };
static char c127[9] = {
	3,-11, 13,			/*, 1, 59, >  */
	-8, 9, 8, 0, -8, -9 };
static char c128[65] = {
	31,-9, 11,			/*, 1, 51, ?  */
	-5, 8, -4, 7, -5, 6, -6, 7, -6, 8, -5, 10, -4, 11, -2, 12,
	1, 12, 4, 11, 5, 10, 6, 8, 6, 6, 5, 4, 4, 3, 0, 1,
	0, -2, 31, 31, 1, 12, 3, 11, 4, 10, 5, 8, 5, 6, 4, 4,
	2, 2, 31, 31, 0, -7, -1, -8, 0, -9, 1, -8, 0, -7};
static char c129[113] = {
	55,-13, 14,			/*, 9, 53, _  */
	5, 4, 4, 6, 2, 7, -1, 7, -3, 6, -4, 5, -5, 2, -5, -1,
	-4, -3, -2, -4, 1, -4, 3, -3, 4, -1, 31, 31, -1, 7, -3, 5,
	-4, 2, -4, -1, -3, -3, -2, -4, 31, 31, 5, 7, 4, -1, 4, -3,
	6, -4, 8, -4, 10, -2, 11, 1, 11, 3, 10, 6, 9, 8, 7, 10,
	5, 11, 2, 12, -1, 12, -4, 11, -6, 10, -8, 8, -9, 6, -10, 3,
	-10, 0, -9, -3, -8, -5, -6, -7, -4, -8, -1, -9, 2, -9, 5, -8,
	7, -7, 8, -6, 31, 31, 6, 7, 5, -1, 5, -3, 6, -4};
static char c130[37] = {
	17,-10, 12,			/*, 4, 1, A  */
	0, 12, -7, -9, 31, 31, 0, 12, 7, -9, 31, 31, 0, 9, 6, -9,
	31, 31, -5, -4, 5, -4, 31, 31, -10, -9, -4, -9, 31, 31, 3, -9,
	10, -9};
static char c131[91] = {
	44,-11, 13,			/*, 4, 2, B  */
	-6, 12, -6, -9, 31, 31, -5, 12, -5, -9, 31, 31, -9, 12, 3, 12,
	6, 11, 7, 10, 8, 8, 8, 6, 7, 4, 6, 3, 3, 2, 31, 31,
	3, 12, 5, 11, 6, 10, 7, 8, 7, 6, 6, 4, 5, 3, 3, 2,
	31, 31, -5, 2, 3, 2, 6, 1, 7, 0, 8, -2, 8, -5, 7, -7,
	6, -8, 3, -9, -9, -9, 31, 31, 3, 2, 5, 1, 6, 0, 7, -2,
	7, -5, 6, -7, 5, -8, 3, -9};
static char c132[43] = {
	20,-11, 13,			/*, 4, 3, C  */
	-7, 12, 6, -9, 31, 31, -6, 12, 7, -9, 31, 31, 7, 12, -7, -9,
	31, 31, -10, 12, -3, 12, 31, 31, 4, 12, 10, 12, 31, 31, -10, -9,
	-4, -9, 31, 31, 3, -9, 10, -9};
static char c133[31] = {
	14,-10, 12,			/*, 4, 4, D  */
	0, 12, -8, -9, 31, 31, 0, 12, 8, -9, 31, 31, 0, 10, 7, -9,
	31, 31, -7, -8, 7, -8, 31, 31, -8, -9, 8, -9};
static char c134[45] = {
	21,-11, 12,			/*, 4, 5, E  */
	-6, 12, -6, -9, 31, 31, -5, 12, -5, -9, 31, 31, 1, 6, 1, -2,
	31, 31, -9, 12, 7, 12, 7, 7, 6, 12, 31, 31, -5, 2, 1, 2,
	31, 31, -9, -9, 7, -9, 7, -4, 6, -9};
static char c135[97] = {
	47,-10, 13,			/*, 4, 6, F  */
	0, 12, 0, -9, 31, 31, 1, 12, 1, -9, 31, 31, -2, 7, -5, 6,
	-6, 5, -7, 3, -7, 0, -6, -2, -5, -3, -2, -4, 3, -4, 6, -3,
	7, -2, 8, 0, 8, 3, 7, 5, 6, 6, 3, 7, -2, 7, 31, 31,
	-2, 7, -4, 6, -5, 5, -6, 3, -6, 0, -5, -2, -4, -3, -2, -4,
	31, 31, 3, -4, 5, -3, 6, -2, 7, 0, 7, 3, 6, 5, 5, 6,
	3, 7, 31, 31, -3, 12, 4, 12, 31, 31, -3, -9, 4, -9};
static char c136[29] = {
	13,-10, 11,			/*, 4, 7, G  */
	-5, 12, -5, -9, 31, 31, -4, 12, -4, -9, 31, 31, -8, 12, 7, 12,
	7, 7, 6, 12, 31, 31, -8, -9, -1, -9};
static char c137[55] = {
	26,-12, 14,			/*, 4, 8, H  */
	-7, 12, -7, -9, 31, 31, -6, 12, -6, -9, 31, 31, 6, 12, 6, -9,
	31, 31, 7, 12, 7, -9, 31, 31, -10, 12, -3, 12, 31, 31, 3, 12,
	10, 12, 31, 31, -6, 2, 6, 2, 31, 31, -10, -9, -3, -9, 31, 31,
	3, -9, 10, -9};
static char c138[25] = {
	11,-5, 8,			/*, 4, 9, I  */
	0, 12, 0, -9, 31, 31, 1, 12, 1, -9, 31, 31, -3, 12, 4, 12,
	31, 31, -3, -9, 4, -9};
static char c139[3] = {
	0,0, 2};			/*, 4, 10, J  */
static char c140[55] = {
	26,-12, 13,			/*, 4, 11, K  */
	-7, 12, -7, -9, 31, 31, -6, 12, -6, -9, 31, 31, 7, 12, -6, -1,
	31, 31, -1, 3, 7, -9, 31, 31, -2, 3, 6, -9, 31, 31, -10, 12,
	-3, 12, 31, 31, 4, 12, 10, 12, 31, 31, -10, -9, -3, -9, 31, 31,
	3, -9, 10, -9};
static char c141[31] = {
	14,-10, 12,			/*, 4, 12, L  */
	0, 12, -7, -9, 31, 31, 0, 12, 7, -9, 31, 31, 0, 9, 6, -9,
	31, 31, -10, -9, -4, -9, 31, 31, 3, -9, 10, -9};
static char c142[61] = {
	29,-12, 15,			/*, 4, 13, M  */
	-7, 12, -7, -9, 31, 31, -6, 12, 0, -6, 31, 31, -7, 12, 0, -9,
	31, 31, 7, 12, 0, -9, 31, 31, 7, 12, 7, -9, 31, 31, 8, 12,
	8, -9, 31, 31, -10, 12, -6, 12, 31, 31, 7, 12, 11, 12, 31, 31,
	-10, -9, -4, -9, 31, 31, 4, -9, 11, -9};
static char c143[43] = {
	20,-11, 14,			/*, 4, 14, N  */
	-6, 12, -6, -9, 31, 31, -5, 12, 7, -7, 31, 31, -5, 10, 7, -9,
	31, 31, 7, 12, 7, -9, 31, 31, -9, 12, -5, 12, 31, 31, 4, 12,
	10, 12, 31, 31, -9, -9, -3, -9};
static char c144[89] = {
	43,-11, 13,			/*, 4, 15, O  */
	-1, 12, -4, 11, -6, 9, -7, 7, -8, 3, -8, 0, -7, -4, -6, -6,
	-4, -8, -1, -9, 1, -9, 4, -8, 6, -6, 7, -4, 8, 0, 8, 3,
	7, 7, 6, 9, 4, 11, 1, 12, -1, 12, 31, 31, -1, 12, -3, 11,
	-5, 9, -6, 7, -7, 3, -7, 0, -6, -4, -5, -6, -3, -8, -1, -9,
	31, 31, 1, -9, 3, -8, 5, -6, 6, -4, 7, 0, 7, 3, 6, 7,
	5, 9, 3, 11, 1, 12};
static char c145[43] = {
	20,-12, 14,			/*, 4, 16, P  */
	-7, 12, -7, -9, 31, 31, -6, 12, -6, -9, 31, 31, 6, 12, 6, -9,
	31, 31, 7, 12, 7, -9, 31, 31, -10, 12, 10, 12, 31, 31, -10, -9,
	-3, -9, 31, 31, 3, -9, 10, -9};
static char c146[113] = {
	55,-11, 13,			/*, 4, 17, Q  */
	-1, 12, -4, 11, -6, 9, -7, 7, -8, 3, -8, 0, -7, -4, -6, -6,
	-4, -8, -1, -9, 1, -9, 4, -8, 6, -6, 7, -4, 8, 0, 8, 3,
	7, 7, 6, 9, 4, 11, 1, 12, -1, 12, 31, 31, -1, 12, -3, 11,
	-5, 9, -6, 7, -7, 3, -7, 0, -6, -4, -5, -6, -3, -8, -1, -9,
	31, 31, 1, -9, 3, -8, 5, -6, 6, -4, 7, 0, 7, 3, 6, 7,
	5, 9, 3, 11, 1, 12, 31, 31, -3, 5, -3, -2, 31, 31, 3, 5,
	3, -2, 31, 31, -3, 2, 3, 2, 31, 31, -3, 1, 3, 1};
static char c147[59] = {
	28,-11, 13,			/*, 4, 18, R  */
	-6, 12, -6, -9, 31, 31, -5, 12, -5, -9, 31, 31, -9, 12, 3, 12,
	6, 11, 7, 10, 8, 8, 8, 5, 7, 3, 6, 2, 3, 1, -5, 1,
	31, 31, 3, 12, 5, 11, 6, 10, 7, 8, 7, 5, 6, 3, 5, 2,
	3, 1, 31, 31, -9, -9, -2, -9};
static char c148[39] = {
	18,-10, 12,			/*, 4, 19, S  */
	-7, 12, 0, 2, -8, -9, 31, 31, -8, 12, -1, 2, 31, 31, -8, 12,
	6, 12, 7, 8, 5, 12, 31, 31, -7, -8, 6, -8, 31, 31, -8, -9,
	6, -9, 7, -5};
static char c149[33] = {
	15,-9, 12,			/*, 4, 20, T  */
	0, 12, 0, -9, 31, 31, 1, 12, 1, -9, 31, 31, -6, 12, -7, 7,
	-7, 12, 8, 12, 8, 7, 7, 12, 31, 31, -3, -9, 4, -9};
static char c150[47] = {
	22,-9, 12,			/*, 4, 21, U  */
	-7, 7, -7, 9, -6, 11, -5, 12, -3, 12, -2, 11, -1, 9, 0, 5,
	0, -9, 31, 31, 8, 7, 8, 9, 7, 11, 6, 12, 4, 12, 3, 11,
	2, 9, 1, 5, 1, -9, 31, 31, -3, -9, 4, -9};
static char c151[3] = {
	0,0, 2};			/*, 4, 22, V  */
static char c152[87] = {
	42,-11, 13,			/*, 4, 23, W  */
	-8, -6, -7, -9, -3, -9, -5, -5, -7, -2, -8, 2, -8, 6, -7, 9,
	-5, 11, -2, 12, 2, 12, 5, 11, 7, 9, 8, 6, 8, 2, 7, -2,
	5, -5, 3, -9, 7, -9, 8, -6, 31, 31, -5, -5, -6, -2, -7, 2,
	-7, 6, -6, 9, -4, 11, -2, 12, 31, 31, 2, 12, 4, 11, 6, 9,
	7, 6, 7, 2, 6, -2, 5, -5, 31, 31, -7, -8, -4, -8, 31, 31,
	4, -8, 7, -8};
static char c153[73] = {
	35,-11, 13,			/*, 4, 24, X  */
	-7, 13, -8, 8, 31, 31, 8, 13, 7, 8, 31, 31, -3, 4, -4, -1,
	31, 31, 4, 4, 3, -1, 31, 31, -7, -5, -8, -10, 31, 31, 8, -5,
	7, -10, 31, 31, -7, 11, 7, 11, 31, 31, -7, 10, 7, 10, 31, 31,
	-3, 2, 3, 2, 31, 31, -3, 1, 3, 1, 31, 31, -7, -7, 7, -7,
	31, 31, -7, -8, 7, -8};
static char c154[83] = {
	40,-11, 14,			/*, 4, 25, Y  */
	0, 12, 0, -9, 31, 31, 1, 12, 1, -9, 31, 31, -9, 5, -8, 6,
	-6, 5, -5, 1, -4, -1, -3, -2, -1, -3, 31, 31, -8, 6, -7, 5,
	-6, 1, -5, -1, -4, -2, -1, -3, 2, -3, 5, -2, 6, -1, 7, 1,
	8, 5, 9, 6, 31, 31, 2, -3, 4, -2, 5, -1, 6, 1, 7, 5,
	9, 6, 10, 5, 31, 31, -3, 12, 4, 12, 31, 31, -3, -9, 4, -9};
static char c155[33] = {
	15,-10, 12,			/*, 4, 26, Z  */
	6, 12, -7, -9, 31, 31, 7, 12, -6, -9, 31, 31, -6, 12, -7, 7,
	-7, 12, 7, 12, 31, 31, -7, -9, 7, -9, 7, -4, 6, -9};
static char c156[13] = {
	5,-10, 10,			/*, box   */
	-8, -8, -8, 8, 8, 8, 8, -8, -8, -8};
static char c157[93] = {
	45,-8, 8,			/*, 9, 55, &  */
	3, 9, 2, 8, 3, 7, 4, 8, 4, 9, 3, 11, 1, 12, -1, 12,
	-3, 11, -4, 9, -4, 7, -3, 5, -1, 3, 4, 0, 31, 31, -3, 5,
	2, 2, 4, 0, 5, -2, 5, -4, 4, -6, 2, -8, 31, 31, -2, 4,
	-4, 2, -5, 0, -5, -2, -4, -4, -2, -6, 3, -9, 31, 31, -4, -4,
	1, -7, 3, -9, 4, -11, 4, -13, 3, -15, 1, -16, -1, -16, -3, -15,
	-4, -13, -4, -12, -3, -11, -2, -12, -3, -13};
static char c158[13] = {
	5,-10, 10,			/*, diamond   */
	-8, 0, 0, 8, 8, 0, 0, -8, -8, 0};
static char c159[29] = {
	13,-7, 7,			/*, 9, 7, G  */
	-1, 12, -3, 11, -4, 9, -4, 7, -3, 5, -1, 4, 1, 4, 3, 5,
	4, 7, 4, 9, 3, 11, 1, 12, -1, 12};
static char c160[53] = {
	25,-12, 13,			/*, 9, 50, ]  */
	10, -1, 9, -3, 7, -4, 5, -4, 3, -3, 2, -2, -1, 2, -2, 3,
	-4, 4, -6, 4, -8, 3, -9, 1, -9, -1, -8, -3, -6, -4, -4, -4,
	-2, -3, -1, -2, 2, 2, 3, 3, 5, 4, 7, 4, 9, 3, 10, 1,
	10, -1};
static char c161[15] = {
	6,-6, 6,			/*, 9, 30, 3, */
	-2, 12, 3, 6, 31, 31, -2, 12, -3, 11, 3, 6};
static char c162[81] = {
	39,-11, 14,			/*, 3, 1, A  */
	-1, 5, -4, 4, -6, 2, -7, 0, -8, -3, -8, -6, -7, -8, -4, -9,
	-2, -9, 0, -8, 3, -5, 5, -2, 7, 2, 8, 5, 31, 31, -1, 5,
	-3, 4, -5, 2, -6, 0, -7, -3, -7, -6, -6, -8, -4, -9, 31, 31,
	-1, 5, 1, 5, 4, 4, 5, 1, 6, -5, 7, -8, 8, -9, 31, 31,
	1, 5, 3, 4, 4, 1, 5, -5, 6, -8, 8, -9, 9, -9};
static char c163[115] = {
	56,-11, 12,			/*, 3, 2, B  */
	2, 12, -1, 11, -3, 9, -5, 5, -6, 2, -7, -2, -8, -8, -9, -16,
	31, 31, 2, 12, 0, 11, -2, 9, -4, 5, -5, 2, -6, -2, -7, -8,
	-8, -16, 31, 31, 2, 12, 4, 12, 6, 11, 7, 10, 7, 7, 6, 5,
	5, 4, 2, 3, -1, 3, 31, 31, 4, 12, 6, 10, 6, 7, 5, 5,
	4, 4, 2, 3, 31, 31, -1, 3, 2, 2, 4, 1, 5, 0, 6, -2,
	6, -5, 5, -7, 4, -8, 1, -9, -2, -9, -4, -8, -5, -7, -6, -4,
	31, 31, 2, 2, 4, 0, 5, -2, 5, -5, 4, -7, 3, -8, 1, -9};
static char c164[43] = {
	20,-11, 12,			/*, 3, 3, C  */
	-9, 5, -7, 5, -5, 4, -4, 3, 3, -14, 5, -16, 31, 31, -7, 5,
	-5, 3, 2, -14, 3, -15, 5, -16, 7, -16, 31, 31, 8, 5, 7, 3,
	4, -1, -6, -10, -9, -14, -10, -16};
static char c165[77] = {
	37,-9, 12,			/*, 3, 4, D  */
	4, 4, 2, 5, 0, 5, -3, 4, -5, 1, -6, -2, -6, -5, -5, -7,
	-4, -8, -2, -9, 0, -9, 3, -8, 5, -5, 6, -2, 6, 1, 5, 3,
	1, 7, 0, 9, 0, 11, 1, 12, 3, 12, 5, 11, 7, 9, 31, 31,
	0, 5, -2, 4, -4, 1, -5, -2, -5, -6, -4, -8, 31, 31, 0, -9,
	2, -8, 4, -5, 5, -2, 5, 2, 4, 4};
static char c166[51] = {
	24,-9, 10,			/*, 3, 5, E  */
	5, 4, 3, 5, 0, 5, -3, 4, -5, 2, -6, -1, -6, -4, -5, -7,
	-4, -8, -1, -9, 2, -9, 4, -8, 31, 31, 0, 5, -2, 4, -4, 2,
	-5, -1, -5, -4, -4, -7, -3, -8, -1, -9, 31, 31, -5, -2, 3, -2};
static char c167[85] = {
	41,-11, 13,			/*, 3, 6, F  */
	3, 12, -3, -16, 31, 31, 4, 12, -4, -16, 31, 31, -1, 5, -5, 4,
	-7, 2, -8, -1, -8, -4, -7, -6, -5, -8, -2, -9, 1, -9, 5, -8,
	7, -6, 8, -3, 8, 0, 7, 2, 5, 4, 2, 5, -1, 5, 31, 31,
	-1, 5, -4, 4, -6, 2, -7, -1, -7, -4, -6, -6, -4, -8, -2, -9,
	31, 31, 1, -9, 4, -8, 6, -6, 7, -3, 7, 0, 6, 2, 4, 4,
	2, 5};
static char c168[59] = {
	28,-9, 13,			/*, 3, 7, G  */
	-8, 2, -6, 4, -4, 5, -3, 5, -1, 4, 0, 3, 1, 0, 1, -4,
	0, -9, -2, -16, 31, 31, -7, 3, -5, 4, -2, 4, 0, 3, 31, 31,
	9, 5, 8, 2, 5, -2, 2, -6, 0, -9, -2, -13, -3, -16, 31, 31,
	8, 5, 7, 2, 5, -1, 2, -6};
static char c169[63] = {
	30,-11, 13,			/*, 3, 8, H  */
	-9, 1, -7, 4, -5, 5, -3, 4, -3, 2, -4, -2, -6, -9, 31, 31,
	-5, 5, -4, 4, -4, 2, -5, -2, -7, -9, 31, 31, -4, -2, -2, 2,
	0, 4, 2, 5, 4, 5, 6, 4, 7, 3, 7, 0, 6, -5, 3, -16,
	31, 31, 4, 5, 6, 3, 6, 0, 5, -5, 2, -16};
static char c170[29] = {
	13,-6, 8,			/*, 3, 9, I  */
	0, 5, -2, -2, -3, -6, -3, -8, -1, -9, 1, -8, 3, -5, 31, 31,
	1, 5, -1, -2, -2, -6, -2, -8, -1, -9};
static char c171[3] = {
	0,0, 2};			/*, 3, 10, J  */
static char c172[53] = {
	25,-10, 12,			/*, 3, 11, K  */
	-4, 5, -8, -9, 31, 31, -3, 5, -7, -9, 31, 31, 7, 4, 6, 5,
	5, 5, 3, 4, -1, 0, -3, -1, -5, -1, 31, 31, -3, -1, -1, -2,
	2, -8, 3, -9, 31, 31, -3, -1, -2, -2, 1, -8, 3, -9, 5, -8,
	7, -5};
static char c173[43] = {
	20,-9, 13,			/*, 3, 12, L  */
	-6, 12, -4, 12, -2, 11, -1, 10, 1, 5, 7, -8, 8, -9, 31, 31,
	-4, 12, -2, 10, 0, 5, 6, -8, 8, -9, 9, -9, 31, 31, 0, 5,
	-7, -9, 31, 31, 0, 5, -6, -9};
static char c174[55] = {
	26,-11, 13,			/*, 3, 13, M  */
	-5, 5, -11, -16, 31, 31, -4, 5, -10, -16, 31, 31, -5, 1, -6, -4,
	-6, -7, -4, -9, -2, -9, 0, -8, 2, -6, 4, -2, 31, 31, 6, 5,
	3, -6, 3, -8, 5, -9, 7, -8, 9, -5, 31, 31, 7, 5, 4, -6,
	4, -8, 5, -9};
static char c175[49] = {
	23,-10, 13,			/*, 3, 14, N  */
	-4, 5, -6, -9, 31, 31, -3, 5, -4, -1, -5, -6, -6, -9, 31, 31,
	7, 5, 6, 1, 4, -3, 31, 31, 8, 5, 7, 2, 6, 0, 4, -3,
	2, -5, -1, -7, -3, -8, -6, -9, 31, 31, -7, 5, -3, 5};
static char c176[65] = {
	31,-9, 11,			/*, 3, 15, O  */
	0, 5, -3, 4, -5, 1, -6, -2, -6, -5, -5, -7, -4, -8, -2, -9,
	0, -9, 3, -8, 5, -5, 6, -2, 6, 1, 5, 3, 4, 4, 2, 5,
	0, 5, 31, 31, 0, 5, -2, 4, -4, 1, -5, -2, -5, -6, -4, -8,
	31, 31, 0, -9, 2, -8, 4, -5, 5, -2, 5, 2, 4, 4};
static char c177[45] = {
	21,-11, 13,			/*, 3, 16, P  */
	-2, 4, -6, -9, 31, 31, -2, 4, -5, -9, 31, 31, 4, 4, 4, -9,
	31, 31, 4, 4, 5, -9, 31, 31, -9, 2, -7, 4, -4, 5, 9, 5,
	31, 31, -9, 2, -7, 3, -4, 4, 9, 4};
static char c178[87] = {
	42,-9, 12,			/*, 3, 17, Q  */
	2, 12, -1, 11, -3, 8, -4, 6, -5, 3, -6, -2, -6, -6, -5, -8,
	-3, -9, -1, -9, 2, -8, 4, -5, 5, -3, 6, 0, 7, 5, 7, 9,
	6, 11, 4, 12, 2, 12, 31, 31, 2, 12, 0, 11, -2, 8, -3, 6,
	-4, 3, -5, -2, -5, -6, -4, -8, -3, -9, 31, 31, -1, -9, 1, -8,
	3, -5, 4, -3, 5, 0, 6, 5, 6, 9, 5, 11, 4, 12, 31, 31,
	-4, 2, 5, 2};
static char c179[63] = {
	30,-10, 11,			/*, 3, 18, R  */
	-6, -4, -5, -7, -4, -8, -2, -9, 0, -9, 3, -8, 5, -5, 6, -2,
	6, 1, 5, 3, 4, 4, 2, 5, 0, 5, -3, 4, -5, 1, -6, -2,
	-10, -16, 31, 31, 0, -9, 2, -8, 4, -5, 5, -2, 5, 2, 4, 4,
	31, 31, 0, 5, -2, 4, -4, 1, -5, -2, -9, -16};
static char c180[71] = {
	34,-10, 14,			/*, 3, 19, S  */
	10, 5, -1, 5, -4, 4, -6, 1, -7, -2, -7, -5, -6, -7, -5, -8,
	-3, -9, -1, -9, 2, -8, 4, -5, 5, -2, 5, 1, 4, 3, 3, 4,
	1, 5, 31, 31, -1, 5, -3, 4, -5, 1, -6, -2, -6, -6, -5, -8,
	31, 31, -1, -9, 1, -8, 3, -5, 4, -2, 4, 2, 3, 4, 31, 31,
	3, 4, 10, 4};
static char c181[33] = {
	15,-10, 12,			/*, 3, 20, T  */
	1, 4, -2, -9, 31, 31, 1, 4, -1, -9, 31, 31, -8, 2, -6, 4,
	-3, 5, 8, 5, 31, 31, -8, 2, -6, 3, -3, 4, 8, 4};
static char c182[51] = {
	24,-11, 12,			/*, 3, 21, U  */
	-9, 1, -7, 4, -5, 5, -3, 4, -3, 2, -5, -4, -5, -7, -3, -9,
	31, 31, -5, 5, -4, 4, -4, 2, -6, -4, -6, -7, -5, -8, -3, -9,
	-1, -9, 2, -8, 4, -6, 6, -3, 7, 1, 7, 5, 6, 5, 7, 3};
static char c183[3] = {
	0,0, 2};			/*, 3, 22, V  */
static char c184[85] = {
	41,-12, 13,			/*, 3, 23, W  */
	-6, 4, -4, 4, -4, 5, -6, 4, -8, 1, -9, -2, -9, -5, -8, -8,
	-7, -9, -5, -9, -3, -8, -1, -5, 0, -2, 31, 31, -9, -5, -8, -7,
	-7, -8, -5, -8, -3, -7, -1, -5, 31, 31, -1, -2, -1, -5, 0, -8,
	1, -9, 3, -9, 5, -8, 7, -5, 8, -2, 8, 1, 7, 4, 6, 5,
	6, 4, 7, 4, 31, 31, -1, -5, 0, -7, 1, -8, 3, -8, 5, -7,
	7, -5};
static char c185[91] = {
	44,-9, 10,			/*, 3, 24, X  */
	2, 12, 0, 11, -1, 10, -1, 9, 0, 8, 3, 7, 6, 7, 31, 31,
	3, 7, -1, 6, -3, 5, -4, 3, -4, 1, -2, -1, 1, -2, 4, -2,
	31, 31, 3, 7, 0, 6, -2, 5, -3, 3, -3, 1, -1, -1, 1, -2,
	31, 31, 1, -2, -3, -3, -5, -4, -6, -6, -6, -8, -4, -10, 1, -12,
	2, -13, 2, -15, 0, -16, -2, -16, 31, 31, 1, -2, -2, -3, -4, -4,
	-5, -6, -5, -8, -3, -10, 1, -12};
static char c186[69] = {
	33,-13, 14,			/*, 3, 25, Y  */
	3, 12, -3, -16, 31, 31, 4, 12, -4, -16, 31, 31, -11, 1, -9, 4,
	-7, 5, -5, 4, -5, 2, -6, -3, -6, -5, -5, -7, -3, -8, 0, -8,
	2, -7, 5, -5, 31, 31, -7, 5, -6, 4, -6, 2, -7, -3, -7, -5,
	-6, -7, -5, -8, -3, -9, -1, -9, 2, -8, 5, -5, 7, -2, 9, 2,
	10, 5};
static char c187[65] = {
	31,-9, 10,			/*, 3, 26, Z  */
	2, 12, 0, 11, -1, 10, -1, 9, 0, 8, 3, 7, 8, 7, 8, 8,
	5, 7, 1, 5, -2, 3, -5, 0, -6, -3, -6, -5, -5, -7, -2, -9,
	1, -11, 2, -13, 2, -15, 1, -16, -1, -16, -2, -14, 31, 31, 5, 7,
	2, 5, -1, 3, -4, 0, -5, -3, -5, -5, -4, -7, -2, -9};
static char c188[65] = {
	31,-12, 12,			/*, 9, 48, @  */
	9, 15, 8, 14, 9, 13, 10, 14, 10, 15, 9, 16, 7, 16, 5, 15,
	3, 13, 2, 11, 1, 8, 0, 4, -2, -8, -3, -12, -4, -14, 31, 31,
	4, 14, 3, 12, 2, 8, 0, -4, -1, -8, -2, -11, -3, -13, -5, -15,
	-7, -16, -9, -16, -10, -15, -10, -14, -9, -13, -8, -14, -9, -15};
static char c189[101] = {
	49,-12, 12,			/*, 9, 49, [  */
	9, 15, 8, 14, 9, 13, 10, 14, 10, 15, 9, 16, 7, 16, 5, 15,
	3, 13, 2, 11, 1, 8, 0, 4, -2, -8, -3, -12, -4, -14, 31, 31,
	4, 14, 3, 12, 2, 8, 0, -4, -1, -8, -2, -11, -3, -13, -5, -15,
	-7, -16, -9, -16, -10, -15, -10, -14, -9, -13, -8, -14, -9, -15, 31, 31,
	-1, 7, -4, 6, -6, 4, -7, 1, -7, -1, -6, -4, -4, -6, -1, -7,
	1, -7, 4, -6, 6, -4, 7, -1, 7, 1, 6, 4, 4, 6, 1, 7,
	-1, 7};
static char c190[91] = {
	44,-9, 10,			/*, 9, 45,  */
	6, 0, 5, 3, 4, 4, 2, 5, 0, 5, -3, 4, -5, 1, -6, -2,
	-6, -5, -5, -7, -4, -8, -2, -9, 0, -9, 3, -8, 5, -6, 6, -3,
	7, 2, 7, 7, 6, 10, 5, 11, 3, 12, 0, 12, -2, 11, -4, 9,
	-4, 8, -3, 8, -3, 9, -2, 11, 31, 31, 0, 5, -2, 4, -4, 1,
	-5, -2, -5, -6, -4, -8, 31, 31, 0, -9, 2, -8, 4, -6, 5, -3,
	6, 2, 6, 7, 5, 10, 3, 12};
static char c191[31] = {
	14,-10, 10,			/*, 9, 46, ,  */
	-8, 12, 0, -9, 31, 31, -7, 12, 0, -7, 31, 31, 8, 12, 0, -9,
	31, 31, -8, 12, 8, 12, 31, 31, -7, 11, 7, 11};
static char c192[53] = {
	25,-12, 13,			/*, 9, 50, ]  */
	10, -1, 9, -3, 7, -4, 5, -4, 3, -3, 2, -2, -1, 2, -2, 3,
	-4, 4, -6, 4, -8, 3, -9, 1, -9, -1, -8, -3, -6, -4, -4, -4,
	-2, -3, -1, -2, 2, 2, 3, 3, 5, 4, 7, 4, 9, 3, 10, 1,
	10, -1};
static char c193[3] = {
	0,-8, 8};			/*, 1, 45,  */
static char c194[31] = {
	14,-4, 6,			/*, 1, 54, !  */
	0, 12, -1, 10, 0, -2, 1, 10, 0, 12, 31, 31, 0, 10, 0, 4,
	31, 31, 0, -7, -1, -8, 0, -9, 1, -8, 0, -7};
static char c195[25] = {
	11,-7, 9,			/*, 1, 61, "  */
	-3, 12, -4, 5, 31, 31, -2, 12, -4, 5, 31, 31, 3, 12, 2, 5,
	31, 31, 4, 12, 2, 5};
static char c196[25] = {
	11,-10, 13,			/*, 1, 52, #  */
	1, 12, -6, -16, 31, 31, 7, 12, 0, -16, 31, 31, -6, 1, 8, 1,
	31, 31, -7, -5, 7, -5};
static char c197[85] = {
	41,-10, 10,			/*, 1, 43, $  */
	-2, 16, -2, -13, 31, 31, 2, 16, 2, -13, 31, 31, 6, 9, 5, 8,
	6, 7, 7, 8, 7, 9, 5, 11, 2, 12, -2, 12, -5, 11, -7, 9,
	-7, 7, -6, 5, -5, 4, -3, 3, 3, 1, 5, 0, 7, -2, 31, 31,
	-7, 7, -5, 5, -3, 4, 3, 2, 5, 1, 6, 0, 7, -2, 7, -6,
	5, -8, 2, -9, -2, -9, -5, -8, -7, -6, -7, -5, -6, -4, -5, -5,
	-6, -6};
static char c198[65] = {
	31,-12, 14,			/*, 1, 60, %  */
	9, 12, -9, -9, 31, 31, -4, 12, -2, 10, -2, 8, -3, 6, -5, 5,
	-7, 5, -9, 7, -9, 9, -8, 11, -6, 12, -4, 12, -2, 11, 1, 10,
	4, 10, 7, 11, 9, 12, 31, 31, 5, -2, 3, -3, 2, -5, 2, -7,
	4, -9, 6, -9, 8, -8, 9, -6, 9, -4, 7, -2, 5, -2};
static char c199[99] = {
	48,-12, 15,			/*, 1, 55, &  */
	9, 4, 8, 3, 9, 2, 10, 3, 10, 4, 9, 5, 8, 5, 7, 4,
	6, 2, 4, -4, 3, -6, 1, -8, -1, -9, -5, -9, -8, -8, -9, -6,
	-9, -3, -8, -1, -2, 3, 0, 5, 1, 7, 1, 9, 0, 11, -2, 12,
	-4, 11, -5, 9, -5, 7, -4, 4, -2, 1, 3, -6, 5, -8, 8, -9,
	9, -9, 10, -8, 10, -7, 31, 31, -5, -9, -7, -8, -8, -6, -8, -3,
	-7, -1, -5, 1, 31, 31, -5, 7, -4, 5, 4, -6, 6, -8, 8, -9};
static char c200[13] = {
	5,-4, 6,			/*, 1, 57, '  */
	0, 12, -1, 5, 31, 31, 1, 12, -1, 5};
static char c201[41] = {
	19,-7, 7,			/*, 1, 41, (  */
	4, 16, 2, 14, 0, 11, -2, 7, -3, 2, -3, -2, -2, -7, 0, -11,
	2, -14, 4, -16, 31, 31, 2, 14, 0, 10, -1, 7, -2, 2, -2, -2,
	-1, -7, 0, -10, 2, -14};
static char c202[41] = {
	19,-7, 7,			/*, 1, 42, )  */
	-4, 16, -2, 14, 0, 11, 2, 7, 3, 2, 3, -2, 2, -7, 0, -11,
	-2, -14, -4, -16, 31, 31, -2, 14, 0, 10, 1, 7, 2, 2, 2, -2,
	1, -7, 0, -10, -2, -14};
static char c203[19] = {
	8,-8, 8,			/*, 1, 39, *  */
	0, 12, 0, 0, 31, 31, -5, 9, 5, 3, 31, 31, 5, 9, -5, 3};
static char c204[13] = {
	5,-12, 12,			/*, 1, 37, +  */
	0, 9, 0, -9, 31, 31, -9, 0, 9, 0};
static char c205[17] = {
	7,-4, 4,			/*, 1, 46, ,  */
	0, -9, -1, -8, 0, -7, 1, -8, 1, -10, 0, -12, -1, -13};
static char c206[7] = {
	2,-12, 12,			/*, 1, 38, -  */
	-9, 0, 9, 0};
static char c207[13] = {
	5,-4, 4,			/*, 1, 47, .  */
	0, -7, -1, -8, 0, -9, 1, -8, 0, -7};
static char c208[7] = {
	2,-11, 11,			/*, 1, 40, /  */
	9, 16, -9, -16};
static char c209[81] = {
	39,-10, 12,			/*, 2, 27, 0, */
	-1, 12, -4, 11, -6, 8, -7, 3, -7, 0, -6, -5, -4, -8, -1, -9,
	1, -9, 4, -8, 6, -5, 7, 0, 7, 3, 6, 8, 4, 11, 1, 12,
	-1, 12, 31, 31, -1, 12, -3, 11, -4, 10, -5, 8, -6, 3, -6, 0,
	-5, -5, -4, -7, -3, -8, -1, -9, 31, 31, 1, -9, 3, -8, 4, -7,
	5, -5, 6, 0, 6, 3, 5, 8, 4, 10, 3, 11, 1, 12};
static char c210[23] = {
	10,-10, 12,			/*, 2, 28, 1, */
	-4, 8, -2, 9, 1, 12, 1, -9, 31, 31, 0, 11, 0, -9, 31, 31,
	-4, -9, 5, -9};
static char c211[91] = {
	44,-10, 12,			/*, 2, 29, 2, */
	-6, 8, -5, 7, -6, 6, -7, 7, -7, 8, -6, 10, -5, 11, -2, 12,
	2, 12, 5, 11, 6, 10, 7, 8, 7, 6, 6, 4, 3, 2, -2, 0,
	-4, -1, -6, -3, -7, -6, -7, -9, 31, 31, 2, 12, 4, 11, 5, 10,
	6, 8, 6, 6, 5, 4, 2, 2, -2, 0, 31, 31, -7, -7, -6, -6,
	-4, -6, 1, -8, 4, -8, 6, -7, 7, -6, 31, 31, -4, -6, 1, -9,
	5, -9, 6, -8, 7, -6, 7, -4};
static char c212[93] = {
	45,-10, 12,			/*, 2, 30, 3, */
	-6, 9, -5, 8, -6, 7, -7, 8, -7, 9, -5, 11, -2, 12, 2, 12,
	5, 11, 6, 9, 6, 6, 5, 4, 2, 3, -1, 3, 31, 31, 2, 12,
	4, 11, 5, 9, 5, 6, 4, 4, 2, 3, 31, 31, 2, 3, 4, 2,
	6, 0, 7, -2, 7, -5, 6, -7, 5, -8, 2, -9, -2, -9, -5, -8,
	-6, -7, -7, -5, -7, -4, -6, -3, -5, -4, -6, -5, 31, 31, 5, 1,
	6, -2, 6, -5, 5, -7, 4, -8, 2, -9};
static char c213[27] = {
	12,-10, 12,			/*, 2, 31, 4, */
	2, 10, 2, -9, 31, 31, 3, 12, 3, -9, 31, 31, 3, 12, -8, -3,
	8, -3, 31, 31, -1, -9, 6, -9};
static char c214[79] = {
	38,-10, 12,			/*, 2, 32, 5, */
	-5, 12, -7, 2, 31, 31, -7, 2, -5, 3, -2, 4, 1, 4, 4, 3,
	6, 1, 7, -2, 7, -3, 6, -6, 4, -8, 1, -9, -2, -9, -5, -8,
	-6, -7, -7, -5, -7, -4, -6, -3, -5, -4, -6, -5, 31, 31, 1, 4,
	3, 3, 5, 1, 6, -2, 6, -3, 5, -6, 3, -8, 1, -9, 31, 31,
	-5, 12, 5, 12, 31, 31, -5, 11, 0, 11, 5, 12};
static char c215[97] = {
	47,-10, 12,			/*, 2, 33, 6, */
	5, 9, 4, 8, 5, 7, 6, 8, 6, 9, 5, 11, 3, 12, 0, 12,
	-3, 11, -5, 9, -6, 7, -7, 3, -7, -3, -6, -6, -4, -8, -1, -9,
	1, -9, 4, -8, 6, -6, 7, -3, 7, -2, 6, 1, 4, 3, 1, 4,
	0, 4, -3, 3, -5, 1, -6, -2, 31, 31, 0, 12, -2, 11, -4, 9,
	-5, 7, -6, 3, -6, -3, -5, -6, -3, -8, -1, -9, 31, 31, 1, -9,
	3, -8, 5, -6, 6, -3, 6, -2, 5, 1, 3, 3, 1, 4};
static char c216[63] = {
	30,-10, 12,			/*, 2, 34, 7, */
	-7, 12, -7, 6, 31, 31, -7, 8, -6, 10, -4, 12, -2, 12, 3, 9,
	5, 9, 6, 10, 7, 12, 31, 31, -6, 10, -4, 11, -2, 11, 3, 9,
	31, 31, 7, 12, 7, 9, 6, 6, 2, 1, 1, -1, 0, -4, 0, -9,
	31, 31, 6, 6, 1, 1, 0, -1, -1, -4, -1, -9};
static char c217[127] = {
	62,-10, 12,			/*, 2, 35, 8, */
	-2, 12, -5, 11, -6, 9, -6, 6, -5, 4, -2, 3, 2, 3, 5, 4,
	6, 6, 6, 9, 5, 11, 2, 12, -2, 12, 31, 31, -2, 12, -4, 11,
	-5, 9, -5, 6, -4, 4, -2, 3, 31, 31, 2, 3, 4, 4, 5, 6,
	5, 9, 4, 11, 2, 12, 31, 31, -2, 3, -5, 2, -6, 1, -7, -1,
	-7, -5, -6, -7, -5, -8, -2, -9, 2, -9, 5, -8, 6, -7, 7, -5,
	7, -1, 6, 1, 5, 2, 2, 3, 31, 31, -2, 3, -4, 2, -5, 1,
	-6, -1, -6, -5, -5, -7, -4, -8, -2, -9, 31, 31, 2, -9, 4, -8,
	5, -7, 6, -5, 6, -1, 5, 1, 4, 2, 2, 3};
static char c218[97] = {
	47,-10, 12,			/*, 2, 36, 9, */
	6, 5, 5, 2, 3, 0, 0, -1, -1, -1, -4, 0, -6, 2, -7, 5,
	-7, 6, -6, 9, -4, 11, -1, 12, 1, 12, 4, 11, 6, 9, 7, 6,
	7, 0, 6, -4, 5, -6, 3, -8, 0, -9, -3, -9, -5, -8, -6, -6,
	-6, -5, -5, -4, -4, -5, -5, -6, 31, 31, -1, -1, -3, 0, -5, 2,
	-6, 5, -6, 6, -5, 9, -3, 11, -1, 12, 31, 31, 1, 12, 3, 11,
	5, 9, 6, 6, 6, 0, 5, -4, 4, -6, 2, -8, 0, -9};
static char c219[25] = {
	11,-4, 6,			/*, 3, 63, ;  */
	0, 5, -1, 4, 0, 3, 1, 4, 0, 5, 31, 31, 0, -7, -1, -8,
	0, -9, 1, -8, 0, -7};
static char c220[29] = {
	13,-4, 6,			/*, 1, 63, ;  */
	0, 5, -1, 4, 0, 3, 1, 4, 0, 5, 31, 31, 0, -9, -1, -8,
	0, -7, 1, -8, 1, -10, 0, -12, -1, -13};
static char c221[9] = {
	3,-11, 13,			/*, 1, 58, <  */
	8, 9, -8, 0, 8, -9};
static char c222[13] = {
	5,-12, 12,			/*, 1, 44, =  */
	-9, 3, 9, 3, 31, 31, -9, -3, 9, -3};
static char c223[9] = {
	3,-11, 13,			/*, 1, 59, >  */
	-8, 9, 8, 0, -8, -9};
static char c224[65] = {
	31,-9, 11,			/*, 1, 51, ?  */
	-5, 8, -4, 7, -5, 6, -6, 7, -6, 8, -5, 10, -4, 11, -2, 12,
	1, 12, 4, 11, 5, 10, 6, 8, 6, 6, 5, 4, 4, 3, 0, 1,
	0, -2, 31, 31, 1, 12, 3, 11, 4, 10, 5, 8, 5, 6, 4, 4,
	2, 2, 31, 31, 0, -7, -1, -8, 0, -9, 1, -8, 0, -7};
static char c225[113] = {
	55,-13, 14,			/*, 9, 53, _  */
	5, 4, 4, 6, 2, 7, -1, 7, -3, 6, -4, 5, -5, 2, -5, -1,
	-4, -3, -2, -4, 1, -4, 3, -3, 4, -1, 31, 31, -1, 7, -3, 5,
	-4, 2, -4, -1, -3, -3, -2, -4, 31, 31, 5, 7, 4, -1, 4, -3,
	6, -4, 8, -4, 10, -2, 11, 1, 11, 3, 10, 6, 9, 8, 7, 10,
	5, 11, 2, 12, -1, 12, -4, 11, -6, 10, -8, 8, -9, 6, -10, 3,
	-10, 0, -9, -3, -8, -5, -6, -7, -4, -8, -1, -9, 2, -9, 5, -8,
	7, -7, 8, -6, 31, 31, 6, 7, 5, -1, 5, -3, 6, -4};
static char c226[61] = {
	29,-13, 11,			/*, 6, 1, A  */
	6, 12, -4, -2, -7, -6, -9, -8, -11, -9, -13, -9, -14, -8, -14, -6,
	-13, -5, -12, -5, -11, -6, 31, 31, 6, 12, 2, -9, 31, 31, 2, -8,
	1, -4, 0, -2, -2, 0, -4, 1, -6, 1, -7, 0, -7, -2, -6, -5,
	-3, -8, 0, -9, 3, -9, 5, -8, 6, -7};
static char c227[95] = {
	46,-13, 14,			/*, 6, 2, B  */
	3, 11, 2, 10, 1, 8, -1, 3, -3, -3, -4, -5, -6, -8, -8, -9,
	-10, -9, -11, -8, -11, -6, -10, -5, -9, -5, -8, -6, 31, 31, -3, 6,
	-4, 4, -5, 3, -7, 3, -8, 4, -8, 6, -7, 8, -5, 10, -3, 11,
	0, 12, 6, 12, 8, 11, 9, 9, 9, 7, 8, 5, 6, 4, 3, 3,
	-1, 3, 31, 31, 3, 3, 5, 2, 6, 1, 7, -1, 7, -4, 6, -7,
	5, -8, 3, -9, 0, -9, -1, -8, -1, -6, 0, -4};
static char c228[67] = {
	32,-12, 13,			/*, 6, 3, C  */
	-7, 10, -8, 8, -8, 6, -7, 4, -4, 3, -1, 3, 3, 4, 5, 5,
	8, 7, 9, 9, 9, 11, 8, 12, 6, 12, 3, 11, 0, 9, -2, 7,
	-4, 4, -5, 2, -6, -1, -6, -4, -5, -7, -4, -8, -2, -9, 0, -9,
	3, -8, 5, -6, 6, -4, 6, -2, 5, 0, 3, 0, 1, -1, 0, -3};
static char c229[71] = {
	34,-13, 13,			/*, 6, 4, D  */
	3, 11, 2, 10, 1, 8, -1, 3, -3, -3, -4, -5, -6, -8, -8, -9,
	-10, -9, -11, -8, -11, -6, -10, -5, -8, -5, -6, -6, -4, -8, -2, -9,
	1, -9, 3, -8, 5, -6, 7, -2, 8, 3, 8, 6, 7, 9, 5, 11,
	3, 12, -2, 12, -5, 11, -7, 9, -8, 7, -8, 5, -7, 4, -5, 4,
	-4, 5, -3, 7};
static char c230[69] = {
	33,-10, 12,			/*, 6, 5, E  */
	5, 9, 4, 8, 4, 6, 5, 5, 7, 5, 8, 7, 8, 9, 7, 11,
	5, 12, 2, 12, 0, 11, -1, 10, -2, 8, -2, 6, -1, 4, 1, 3,
	-1, 3, -4, 2, -6, 0, -7, -2, -7, -5, -6, -7, -5, -8, -3, -9,
	0, -9, 3, -8, 5, -6, 6, -4, 6, -2, 5, 0, 3, 0, 1, -1,
	0, -3};
static char c231[65] = {
	31,-12, 12,			/*, 6, 6, F  */
	-1, 6, -2, 4, -4, 3, -6, 3, -7, 5, -7, 7, -6, 9, -4, 11,
	0, 12, 8, 12, 6, 9, 5, 7, 3, 1, 1, -4, 0, -6, -2, -8,
	-5, -9, -8, -9, -10, -8, -10, -6, -9, -5, -8, -5, -7, -6, 31, 31,
	-3, -1, -2, 0, 0, 1, 5, 1, 7, 2, 8, 4, 6, -2};
static char c232[73] = {
	35,-11, 14,			/*, 6, 7, G  */
	-6, 9, -7, 7, -7, 5, -6, 3, -4, 2, -2, 2, 1, 3, 3, 4,
	6, 7, 7, 10, 7, 11, 6, 12, 5, 12, 3, 11, 1, 9, 0, 7,
	-1, 4, -1, 1, 0, -1, 2, -2, 4, -2, 6, -1, 8, 1, 9, 3,
	7, -3, 5, -6, 2, -8, -1, -9, -4, -9, -7, -8, -8, -7, -8, -5,
	-7, -4, -6, -4, -5, -5};
static char c233[77] = {
	37,-12, 15,			/*, 6, 8, H  */
	-5, 6, -6, 7, -6, 9, -4, 11, -1, 12, 1, 12, -3, 0, -5, -5,
	-7, -8, -9, -9, -11, -9, -12, -8, -12, -6, -11, -5, -10, -5, -9, -6,
	31, 31, -8, -2, -7, -1, -5, 0, 4, 3, 6, 4, 9, 6, 11, 8,
	12, 10, 12, 11, 11, 12, 10, 12, 8, 10, 6, 6, 4, 0, 3, -4,
	3, -7, 4, -9, 5, -9, 7, -8, 9, -6};
static char c234[51] = {
	24,-9, 11,			/*, 6, 9, I  */
	8, 6, 6, 4, 3, 3, 0, 3, -2, 4, -3, 6, -3, 8, -2, 10,
	0, 11, 3, 12, 8, 12, 6, 10, 4, 7, 2, 2, 0, -4, -1, -6,
	-3, -8, -5, -9, -8, -9, -9, -8, -9, -6, -8, -5, -7, -5, -6, -6};
static char c235[53] = {
	25,-9, 11,			/*, 6, 10, J  */
	8, 6, 6, 4, 3, 3, 0, 3, -2, 4, -3, 6, -3, 8, -2, 10,
	0, 11, 3, 12, 8, 12, 6, 10, 4, 7, 2, 2, 0, -4, -1, -7,
	-3, -11, -4, -12, -6, -13, -7, -12, -7, -10, -6, -8, -4, -6, 2, -2,
	4, 0};
static char c236[77] = {
	37,-12, 15,			/*, 6, 11, K  */
	-5, 6, -6, 7, -6, 9, -4, 11, -1, 12, 1, 12, -3, 0, -5, -5,
	-7, -8, -9, -9, -11, -9, -12, -8, -12, -6, -11, -5, -10, -5, -9, -6,
	31, 31, 11, 8, 12, 9, 12, 11, 11, 12, 9, 11, 8, 9, 6, 6,
	5, 5, 3, 4, 0, 3, -2, 3, 31, 31, 0, 3, 1, 2, 2, 0,
	3, -7, 4, -9, 5, -9, 7, -8, 9, -6};
static char c237[67] = {
	32,-11, 12,			/*, 6, 12, L  */
	-5, 9, -6, 7, -6, 5, -5, 3, -3, 2, 0, 2, 3, 3, 5, 4,
	8, 7, 9, 10, 9, 11, 8, 12, 7, 12, 5, 11, 4, 10, 2, 7,
	0, 1, -2, -4, -3, -6, -5, -8, -7, -9, -9, -9, -10, -8, -10, -6,
	-9, -5, -7, -5, -5, -6, -2, -8, 0, -9, 3, -9, 5, -8, 6, -7};
static char c238[67] = {
	32,-15, 16,			/*, 6, 13, M  */
	0, 12, -4, 3, -7, -3, -9, -6, -11, -8, -13, -9, -15, -9, -16, -8,
	-16, -6, -15, -5, -14, -5, -13, -6, 31, 31, 0, 12, -2, 3, -3, -5,
	-3, -9, 31, 31, 8, 12, 4, 3, 2, -1, -1, -6, -3, -9, 31, 31,
	8, 12, 6, 3, 5, -5, 5, -7, 6, -9, 7, -9, 9, -8, 11, -6};
static char c239[67] = {
	32,-12, 15,			/*, 6, 14, N  */
	0, 12, -1, 8, -3, 2, -5, -3, -6, -5, -8, -8, -10, -9, -12, -9,
	-13, -8, -13, -6, -12, -5, -11, -5, -10, -6, 31, 31, 0, 12, 0, 6,
	2, -3, 2, -9, 31, 31, 12, 9, 13, 8, 14, 8, 15, 9, 15, 11,
	14, 12, 12, 12, 10, 11, 8, 8, 7, 6, 5, 1, 3, -5, 2, -9};
static char c240[53] = {
	25,-11, 13,			/*, 6, 15, O  */
	1, 12, -1, 11, -3, 9, -5, 6, -6, 4, -7, 0, -7, -4, -6, -7,
	-5, -8, -3, -9, -1, -9, 2, -8, 4, -6, 6, -3, 7, -1, 8, 3,
	8, 7, 7, 10, 6, 11, 5, 11, 3, 10, 1, 8, -1, 4, -2, -1,
	-2, -4};
static char c241[75] = {
	36,-13, 13,			/*, 6, 16, P  */
	3, 11, 2, 10, 1, 8, -1, 3, -3, -3, -4, -5, -6, -8, -8, -9,
	-10, -9, -11, -8, -11, -6, -10, -5, -9, -5, -8, -6, 31, 31, -3, 6,
	-4, 4, -5, 3, -7, 3, -8, 4, -8, 6, -7, 8, -5, 10, -3, 11,
	0, 12, 5, 12, 7, 11, 8, 10, 9, 8, 9, 5, 8, 3, 7, 2,
	5, 1, 3, 1, 1, 2, 0, 3};
static char c242[67] = {
	32,-10, 12,			/*, 6, 17, Q  */
	3, 8, 3, 6, 2, 4, 1, 3, -1, 2, -3, 2, -4, 4, -4, 6,
	-3, 9, -1, 11, 2, 12, 5, 12, 7, 11, 8, 9, 8, 5, 7, 2,
	5, -1, 1, -5, -2, -7, -4, -8, -7, -9, -9, -9, -10, -8, -10, -6,
	-9, -5, -7, -5, -5, -6, -2, -8, 0, -9, 3, -9, 5, -8, 6, -7};
static char c243[87] = {
	42,-13, 14,			/*, 6, 18, R  */
	3, 11, 2, 10, 1, 8, -1, 3, -3, -3, -4, -5, -6, -8, -8, -9,
	-10, -9, -11, -8, -11, -6, -10, -5, -9, -5, -8, -6, 31, 31, -3, 6,
	-4, 4, -5, 3, -7, 3, -8, 4, -8, 6, -7, 8, -5, 10, -3, 11,
	0, 12, 6, 12, 8, 11, 9, 9, 9, 7, 8, 5, 7, 4, 4, 3,
	-1, 3, 31, 31, 0, 3, 2, 2, 3, 0, 4, -7, 5, -9, 6, -9,
	8, -8, 10, -6};
static char c244[69] = {
	33, -11, 12,			/*, 6, 19, S  */
	-3, 9, -4, 7, -4, 5, -3, 3, -1, 2, 2, 2, 5, 3, 7, 4,
	9, 6, 10, 8, 10, 11, 9, 12, 8, 12, 7, 11, 6, 9, 5, 5,
	4, -1, 3, -4, 2, -6, 0, -8, -3, -9, -6, -9, -8, -8, -9, -6,
	-9, -4, -8, -2, -7, -1, -5, 0, -3, 0, -2, -1, -2, -3, -3, -5,
	-4, -6};
static char c245[49] = {
	23, -10, 12,			/*, 6, 20, T  */
	1, 6, 0, 4, -2, 3, -4, 3, -5, 5, -5, 7, -4, 9, -2, 11,
	2, 12, 10, 12, 8, 9, 7, 7, 5, 1, 3, -4, 2, -6, 0, -8,
	-3, -9, -6, -9, -8, -8, -8, -6, -7, -5, -6, -5, -5, -6};
static char c246[53] = {
	25, -12, 14,			/*, 6, 21, U  */
	-9, 8, -7, 11, -5, 12, -4, 12, -3, 10, -3, 7, -4, 3, -5, 0,
	-6, -4, -6, -7, -5, -9, -3, -9, -1, -8, 2, -5, 4, -2, 6, 3,
	31, 31, 9, 12, 5, 0, 4, -4, 4, -7, 5, -9, 6, -9, 8, -8,
	10, -6};
static char c247[59] = {
	28, -12, 14,			/*, 6, 22, V  */
	-9, 8, -7, 11, -5, 12, -4, 12, -3, 10, -3, 7, -4, 3, -5, 0,
	-6, -4, -6, -7, -5, -9, -3, -9, -1, -8, 2, -5, 4, -2, 6, 2,
	7, 5, 8, 9, 8, 11, 7, 12, 6, 12, 5, 11, 4, 9, 4, 6,
	5, 4, 7, 2, 9, 1, 11, 1};
static char c248[69] = {
	33, -14, 15,			/*, 6, 23, W  */
	-9, 6, -10, 6, -11, 7, -11, 9, -10, 11, -8, 12, -4, 12, -5, 10,
	-6, 5, -6, -3, -7, -9, 31, 31, 4, 12, 2, 10, 1, 8, -1, 3,
	-3, -3, -5, -7, -7, -9, 31, 31, 4, 12, 3, 10, 2, 5, 2, -3,
	1, -9, 31, 31, 12, 12, 10, 10, 9, 8, 7, 3, 5, -3, 3, -7,
	1, -9};
static char c249[93] = {
	45, -12, 14,			/*, 6, 24, X  */
	-3, 7, -4, 6, -6, 6, -7, 7, -7, 9, -6, 11, -4, 12, -2, 12,
	0, 11, 1, 9, 1, 6, 0, 2, -2, -3, -4, -6, -6, -8, -8, -9,
	-10, -9, -11, -8, -11, -6, -10, -5, -9, -5, -8, -6, 31, 31, 8, 9,
	9, 8, 10, 8, 11, 9, 11, 11, 10, 12, 8, 12, 6, 11, 4, 9,
	2, 6, 0, 2, -1, -3, -1, -6, 0, -8, 2, -9, 4, -9, 6, -8,
	7, -6, 7, -4, 6, -3, 4, -3, 3, -4};
static char c250[59] = {
	28, -11, 13,			/*, 6, 25, Y  */
	-7, 8, -5, 11, -3, 12, -2, 12, -1, 11, -1, 9, -3, 3, -3, 0,
	-2, -2, 0, -2, 3, -1, 5, 1, 7, 4, 8, 6, 31, 31, 10, 12,
	8, 6, 5, -3, 3, -6, 1, -8, -2, -9, -5, -9, -8, -8, -9, -6,
	-9, -4, -8, -3, -7, -3, -6, -4};
static char c251[59] = {
	28, -10, 13,			/*, 6, 26, Z  */
	2, 6, 1, 4, -1, 3, -3, 3, -4, 5, -4, 7, -3, 9, -1, 11,
	3, 12, 11, 12, 9, 9, 7, 5, 4, -2, 2, -5, 0, -7, -2, -8,
	-6, -9, -9, -9, -10, -8, -10, -6, -9, -5, -7, -5, -5, -6, -2, -8,
	0, -9, 3, -9, 5, -8, 6, -7};
static char c252[13] = {
	5, -10, 10,			/*, box   */
	-8, -8, -8, 8, 8, 8, 8, -8, -8, -8};
static char c253[93] = {
	45, -8, 8,			/*, 9, 55, &  */
	3, 9, 2, 8, 3, 7, 4, 8, 4, 9, 3, 11, 1, 12, -1, 12,
	-3, 11, -4, 9, -4, 7, -3, 5, -1, 3, 4, 0, 31, 31, -3, 5,
	2, 2, 4, 0, 5, -2, 5, -4, 4, -6, 2, -8, 31, 31, -2, 4,
	-4, 2, -5, 0, -5, -2, -4, -4, -2, -6, 3, -9, 31, 31, -4, -4,
	1, -7, 3, -9, 4, -11, 4, -13, 3, -15, 1, -16, -1, -16, -3, -15,
	-4, -13, -4, -12, -3, -11, -2, -12, -3, -13};
static char c254[13] = {
	5, -10, 10,			/*, diamond   */
	-8, 0, 0, 8, 8, 0, 0, -8, -8, 0};
static char c255[29] = {
	13, -7, 7,			/*, 9, 7, G  */
	-1, 12, -3, 11, -4, 9, -4, 7, -3, 5, -1, 4, 1, 4, 3, 5,
	4, 7, 4, 9, 3, 11, 1, 12, -1, 12};
static char c256[53] = {
	25, -12, 13,			/*, 9, 50, ]  */
	10, -1, 9, -3, 7, -4, 5, -4, 3, -3, 2, -2, -1, 2, -2, 3,
	-4, 4, -6, 4, -8, 3, -9, 1, -9, -1, -8, -3, -6, -4, -4, -4,
	-2, -3, -1, -2, 2, 2, 3, 3, 5, 4, 7, 4, 9, 3, 10, 1,
	10, -1};
static char c257[15] = {
	6, -6, 6,			/*, 9, 30, 3, */
	-2, 12, 3, 6, 31, 31, -2, 12, -3, 11, 3, 6};
static char c258[47] = {
	22, -6, 11,			/*, 5, 1, A  */
	3, -3, 2, -1, 0, 0, -2, 0, -4, -1, -5, -2, -6, -4, -6, -6,
	-5, -8, -3, -9, -1, -9, 1, -8, 2, -6, 31, 31, 4, 0, 2, -6,
	2, -8, 3, -9, 4, -9, 6, -8, 7, -7, 9, -4};
static char c259[47] = {
	22, -5, 11,			/*, 5, 2, B  */
	-5, -4, -3, -1, 0, 4, 1, 6, 2, 9, 2, 11, 1, 12, -1, 11,
	-2, 9, -3, 5, -4, -2, -4, -8, -3, -9, -2, -9, 0, -8, 2, -6,
	3, -3, 3, 0, 4, -4, 5, -5, 7, -5, 9, -4};
static char c260[29] = {
	13, -5, 8,			/*, 5, 3, C  */
	2, -2, 2, -1, 1, 0, -1, 0, -3, -1, -4, -2, -5, -4, -5, -6,
	-4, -8, -2, -9, 1, -9, 4, -7, 6, -4};
static char c261[47] = {
	22, -6, 11,			/*, 5, 4, D  */
	3, -3, 2, -1, 0, 0, -2, 0, -4, -1, -5, -2, -6, -4, -6, -6,
	-5, -8, -3, -9, -1, -9, 1, -8, 2, -6, 31, 31, 8, 12, 2, -6,
	2, -8, 3, -9, 4, -9, 6, -8, 7, -7, 9, -4};
static char c262[35] = {
	16, -5, 8,			/*, 5, 5, E  */
	-3, -7, -1, -6, 0, -5, 1, -3, 1, -1, 0, 0, -1, 0, -3, -1,
	-4, -3, -4, -6, -3, -8, -1, -9, 1, -9, 3, -8, 4, -7, 6, -4};
static char c263[49] = {
	23, -3, 7,			/*, 5, 6, F  */
	-3, -4, 1, 1, 3, 4, 4, 6, 5, 9, 5, 11, 4, 12, 2, 11,
	1, 9, -1, 1, -4, -8, -7, -15, -8, -18, -8, -20, -7, -21, -5, -20,
	-4, -17, -3, -8, -2, -9, 0, -9, 2, -8, 3, -7, 5, -4};
static char c264[57] = {
	27, -6, 11,			/*, 5, 7, G  */
	3, -3, 2, -1, 0, 0, -2, 0, -4, -1, -5, -2, -6, -4, -6, -6,
	-5, -8, -3, -9, -1, -9, 1, -8, 2, -7, 31, 31, 4, 0, 2, -7,
	-2, -18, -3, -20, -5, -21, -6, -20, -6, -18, -5, -15, -2, -12, 1, -10,
	3, -9, 6, -7, 9, -4};
static char c265[59] = {
	28, -5, 12,			/*, 5, 8, H  */
	-5, -4, -3, -1, 0, 4, 1, 6, 2, 9, 2, 11, 1, 12, -1, 11,
	-2, 9, -3, 5, -4, -1, -5, -9, 31, 31, -5, -9, -4, -6, -3, -4,
	-1, -1, 1, 0, 3, 0, 4, -1, 4, -3, 3, -6, 3, -8, 4, -9,
	5, -9, 7, -8, 8, -7, 10, -4};
static char c266[33] = {
	15, -2, 7,			/*, 5, 9, I  */
	1, 5, 1, 4, 2, 4, 2, 5, 1, 5, 31, 31, -2, -4, 0, 0,
	-2, -6, -2, -8, -1, -9, 0, -9, 2, -8, 3, -7, 5, -4};
static char c267[41] = {
	19, -2, 7,			/*, 5, 10, J  */
	1, 5, 1, 4, 2, 4, 2, 5, 1, 5, 31, 31, -2, -4, 0, 0,
	-6, -18, -7, -20, -9, -21, -10, -20, -10, -18, -9,-15,-6,-12,-3,-10,
	-1, -9, 2, -7, 5, -4};
static char c268[67] = {
	32, -5, 11,			/*, 5, 11, K  */
	-5, -4, -3, -1, 0, 4, 1, 6, 2, 9, 2, 11, 1, 12, -1, 11,
	-2, 9, -3, 5, -4, -1, -5, -9, 31, 31, -5, -9, -4, -6, -3, -4,
	-1, -1, 1, 0, 3, 0, 4, -1, 4, -3, 2, -4, -1, -4, 31, 31,
	-1, -4, 1, -5, 2, -8, 3, -9, 4, -9, 6, -8, 7, -7, 9, -4};
static char c269[37] = {
	17, -3, 7,			/*, 5, 12, L  */
	-3, -4, -1, -1, 2, 4, 3, 6, 4, 9, 4, 11, 3, 12, 1, 11,
	0, 9, -1, 5, -2, -2, -2, -8, -1, -9, 0, -9, 2, -8, 3, -7,
	5, -4};
static char c270[67] = {
	32, -13, 14,			/*, 5, 13, M  */
	-13, -4, -11, -1, -9, 0, -8, -1, -8, -2, -9, -6, -10, -9, 31, 31,
	-9, -6, -8, -4, -6, -1, -4, 0, -2, 0, -1, -1, -1, -2, -2, -6,
	-3, -9, 31, 31, -2, -6, -1, -4, 1, -1, 3, 0, 5, 0, 6, -1,
	6, -3, 5, -6, 5, -8, 6, -9, 7, -9, 9, -8, 10, -7, 12, -4};
static char c271[47] = {
	22, -8, 12,			/*, 5, 14, N  */
	-8, -4, -6, -1, -4, 0, -3, -1, -3, -2, -4, -6, -5, -9, 31, 31,
	-4, -6, -3, -4, -1, -1, 1, 0, 3, 0, 4, -1, 4, -3, 3, -6,
	3, -8, 4, -9, 5, -9, 7, -8, 8, -7, 10, -4};
static char c272[47] = {
	22, -6, 10,			/*, 5, 15, O  */
	0, 0, -2, 0, -4, -1, -5, -2, -6, -4, -6, -6, -5, -8, -3, -9,
	-1, -9, 1, -8, 2, -7, 3, -5, 3, -3, 2, -1, 0, 0, -1, -1,
	-1, -3, 0, -5, 2, -6, 5, -6, 7, -5, 8, -4};
static char c273[49] = {
	23, -7, 10,			/*, 5, 16, P  */
	-7, -4, -5, -1, -4, 1, -5, -3, -11, -21, 31, 31, -5, -3, -4, -1,
	-2, 0, 0, 0, 2, -1, 3, -3, 3, -5, 2, -7, 1, -8, -1, -9,
	31, 31, -5, -8, -3, -9, 0, -9, 3, -8, 5, -7, 8, -4};
static char c274[55] = {
	26, -6, 11,			/*, 5, 17, Q  */
	3, -3, 2, -1, 0, 0, -2, 0, -4, -1, -5, -2, -6, -4, -6, -6,
	-5, -8, -3, -9, -1, -9, 1, -8, 31, 31, 4, 0, 3, -3, 1, -8,
	-2, -15, -3, -18, -3, -20, -2, -21, 0, -20, 1, -17, 1, -10, 3, -9,
	6, -7, 9, -4};
static char c275[31] = {
	14, -5, 10,			/*, 5, 18, R  */
	-5, -4, -3, -1, -2, 1, -2, -1, 1, -1, 2, -2, 2, -4, 1, -7,
	1, -8, 2, -9, 3, -9, 5, -8, 6, -7, 8, -4};
static char c276[33] = {
	15, -4, 9,			/*, 5, 19, S  */
	-4, -4, -2, -1, -1, 1, -1, -1, 1, -4, 2, -6, 2, -8, 0, -9,
	31, 31, -4, -8, -2, -9, 2, -9, 4, -8, 5, -7, 7, -4};
static char c277[33] = {
	15, -3, 8,			/*, 5, 20, T  */
	-3, -4, -1, -1, 1, 3, 31, 31, 4, 12, -2, -6, -2, -8, -1, -9,
	1, -9, 3, -8, 4, -7, 6, -4, 31, 31, -2, 4, 5, 4};
static char c278[39] = {
	18, -6, 11,			/*, 5, 21, U  */
	-6, -4, -4, 0, -6, -6, -6, -8, -5, -9, -3, -9, -1, -8, 1, -6,
	3, -3, 31, 31, 4, 0, 2, -6, 2, -8, 3, -9, 4, -9, 6, -8,
	7, -7, 9, -4};
static char c279[35] = {
	16, -6, 11,			/*, 5, 22, V  */
	-6, -4, -4, 0, -5, -5, -5, -8, -4, -9, -3, -9, 0, -8, 2, -6,
	3, -3, 3, 0, 31, 31, 3, 0, 4, -4, 5, -5, 7, -5, 9, -4};
static char c280[51] = {
	24, -9, 14,			/*, 5, 23, W  */
	-6, 0, -8, -2, -9, -5, -9, -7, -8, -9, -6, -9, -4, -8, -2, -6,
	31, 31, 0, 0, -2, -6, -2, -8, -1, -9, 1, -9, 3, -8, 5, -6,
	6, -3, 6, 0, 31, 31, 6, 0, 7, -4, 8, -5, 10, -5, 12, -4};
static char c281[41] = {
	19, -8, 10,			/*, 5, 24, X  */
	-8, -4, -6, -1, -4, 0, -2, 0, -1, -1, -1, -8, 0, -9, 3, -9,
	6, -7, 8, -4, 31, 31, 5, -1, 4, 0, 2, 0, 1, -1, -3, -8,
	-4, -9, -6, -9, -7, -8};
static char c282[47] = {
	22, -6, 11,			/*, 5, 25, Y  */
	-6, -4, -4, 0, -6, -6, -6, -8, -5, -9, -3, -9, -1, -8, 1, -6,
	3, -3, 31, 31, 4, 0, -2, -18, -3, -20, -5, -21, -6, -20, -6, -18,
	-5, -15, -2, -12, 1, -10, 3, -9, 6, -7, 9, -4};
static char c283[47] = {
	22, -6, 10,			/*, 5, 26, Z  */
	-6, -4, -4, -1, -2, 0, 0, 0, 2, -2, 2, -4, 1, -6, -1, -8,
	-4, -9, -2, -10, -1, -12, -1, -15, -2, -18, -3, -20, -5, -21, -6, -20,
	-6, -18, -5, -15, -2, -12, 1, -10, 5, -7, 8, -4};
static char c284[65] = {
	31, -12, 12,			/*, 9, 48, @  */
	9, 15, 8, 14, 9, 13, 10, 14, 10, 15, 9, 16, 7, 16, 5, 15,
	3, 13, 2, 11, 1, 8, 0, 4, -2, -8, -3, -12, -4, -14, 31, 31,
	4, 14, 3, 12, 2, 8, 0, -4, -1, -8, -2, -11, -3, -13, -5, -15,
	-7, -16, -9, -16, -10, -15, -10, -14, -9, -13, -8, -14, -9, -15};
static char c285[101] = {
	49, -12, 12,			/*, 9, 49, [  */
	9, 15, 8, 14, 9, 13, 10, 14, 10, 15, 9, 16, 7, 16, 5, 15,
	3, 13, 2, 11, 1, 8, 0, 4, -2, -8, -3, -12, -4, -14, 31, 31,
	4, 14, 3, 12, 2, 8, 0, -4, -1, -8, -2, -11, -3, -13, -5, -15,
	-7, -16, -9, -16, -10, -15, -10, -14, -9, -13, -8, -14, -9, -15, 31, 31,
	-1, 7, -4, 6, -6, 4, -7, 1, -7, -1, -6, -4, -4, -6, -1, -7,
	1, -7, 4, -6, 6, -4, 7, -1, 7, 1, 6, 4, 4, 6, 1, 7,
	-1, 7};
static char c286[91] = {
	44, -9, 10,			/*, 9, 45,  */
	6, 0, 5, 3, 4, 4, 2, 5, 0, 5, -3, 4, -5, 1, -6, -2,
	-6, -5, -5, -7, -4, -8, -2, -9, 0, -9, 3, -8, 5, -6, 6, -3,
	7, 2, 7, 7, 6, 10, 5, 11, 3, 12, 0, 12, -2, 11, -4, 9,
	-4, 8, -3, 8, -3, 9, -2, 11, 31, 31, 0, 5, -2, 4, -4, 1,
	-5, -2, -5, -6, -4, -8, 31, 31, 0, -9, 2, -8, 4, -6, 5, -3,
	6, 2, 6, 7, 5, 10, 3, 12};
static char c287[31] = {
	14, -10, 10,			/*, 9, 46, ,  */
	-8, 12, 0, -9, 31, 31, -7, 12, 0, -7, 31, 31, 8, 12, 0, -9,
	31, 31, -8, 12, 8, 12, 31, 31, -7, 11, 7, 11};
static char c288[53] = {
	25, -12, 13,			/*, 9, 50, ]  */
	10, -1, 9, -3, 7, -4, 5, -4, 3, -3, 2, -2, -1, 2, -2, 3,
	-4, 4, -6, 4, -8, 3, -9, 1, -9, -1, -8, -3, -6, -4, -4, -4,
	-2, -3, -1, -2, 2, 2, 3, 3, 5, 4, 7, 4, 9, 3, 10, 1,
	10, -1};
static char c289[3] = {
	0, -8, 8};			/*, 1, 45,  */
static char c290[31] = {
	14, -4, 6,			/*, 1, 54, !  */
	0, 12, -1, 10, 0, -2, 1, 10, 0, 12, 31, 31, 0, 10, 0, 4,
	31, 31, 0, -7, -1, -8, 0, -9, 1, -8, 0, -7};
static char c291[25] = {
	11, -7, 9,			/*, 1, 61, "  */
	-3, 12, -4, 5, 31, 31, -2, 12, -4, 5, 31, 31, 3, 12, 2, 5,
	31, 31, 4, 12, 2, 5};
static char c292[25] = {
	11, -10, 13,			/*, 1, 52, #  */
	1, 12, -6, -16, 31, 31, 7, 12, 0, -16, 31, 31, -6, 1, 8, 1,
	31, 31, -7, -5, 7, -5};
static char c293[85] = {
	41, -10, 10,			/*, 1, 43, $  */
	-2, 16, -2, -13, 31, 31, 2, 16, 2, -13, 31, 31, 6, 9, 5, 8,
	6, 7, 7, 8, 7, 9, 5, 11, 2, 12, -2, 12, -5, 11, -7, 9,
	-7, 7, -6, 5, -5, 4, -3, 3, 3, 1, 5, 0, 7, -2, 31, 31,
	-7, 7, -5, 5, -3, 4, 3, 2, 5, 1, 6, 0, 7, -2, 7, -6,
	5, -8, 2, -9, -2, -9, -5, -8, -7, -6, -7, -5, -6, -4, -5, -5,
	-6, -6};
static char c294[65] = {
	31, -12, 14,			/*, 1, 60, %  */
	9, 12, -9, -9, 31, 31, -4, 12, -2, 10, -2, 8, -3, 6, -5, 5,
	-7, 5, -9, 7, -9, 9, -8, 11, -6, 12, -4, 12, -2, 11, 1, 10,
	4, 10, 7, 11, 9, 12, 31, 31, 5, -2, 3, -3, 2, -5, 2, -7,
	4, -9, 6, -9, 8, -8, 9, -6, 9, -4, 7, -2, 5, -2};
static char c295[99] = {
	48, -12, 15,			/*, 1, 55, &  */
	9, 4, 8, 3, 9, 2, 10, 3, 10, 4, 9, 5, 8, 5, 7, 4,
	6, 2, 4, -4, 3, -6, 1, -8, -1, -9, -5, -9, -8, -8, -9, -6,
	-9, -3, -8, -1, -2, 3, 0, 5, 1, 7, 1, 9, 0, 11, -2, 12,
	-4, 11, -5, 9, -5, 7, -4, 4, -2, 1, 3, -6, 5, -8, 8, -9,
	9, -9, 10, -8, 10, -7, 31, 31, -5, -9, -7, -8, -8, -6, -8, -3,
	-7, -1, -5, 1, 31, 31, -5, 7, -4, 5, 4, -6, 6, -8, 8, -9};
static char c296[13] = {
	5, -4, 6,			/*, 1, 57, '  */
	0, 12, -1, 5, 31, 31, 1, 12, -1, 5};
static char c297[41] = {
	19, -7, 7,			/*, 1, 41, (  */
	4, 16, 2, 14, 0, 11, -2, 7, -3, 2, -3, -2, -2, -7, 0, -11,
	2, -14, 4, -16, 31, 31, 2, 14, 0, 10, -1, 7, -2, 2, -2, -2,
	-1, -7, 0, -10, 2, -14};
static char c298[41] = {
	19, -7, 7,			/*, 1, 42, )  */
	-4, 16, -2, 14, 0, 11, 2, 7, 3, 2, 3, -2, 2, -7, 0, -11,
	-2, -14, -4, -16, 31, 31, -2, 14, 0, 10, 1, 7, 2, 2, 2, -2,
	1, -7, 0, -10, -2, -14};
static char c299[19] = {
	8, -8, 8,			/*, 1, 39, *  */
	0, 12, 0, 0, 31, 31, -5, 9, 5, 3, 31, 31, 5, 9, -5, 3};
static char c300[13] = {
	5, -12, 12,			/*, 1, 37, +  */
	0, 9, 0, -9, 31, 31, -9, 0, 9, 0};
static char c301[17] = {
	7, -4, 4,			/*, 1, 46, ,  */
	0, -9, -1, -8, 0, -7, 1, -8, 1, -10, 0, -12, -1, -13};
static char c302[7] = {
	2, -12, 12,			/*, 1, 38, -  */
	-9, 0, 9, 0};
static char c303[13] = {
	5, -4, 4,			/*, 1, 47, .  */
	0, -7, -1, -8, 0, -9, 1, -8, 0, -7};
static char c304[7] = {
	2, -11, 11,			/*, 1, 40, /  */
	9, 16, -9, -16};
static char c305[85] = {
	41, -10, 12,			/*, 7, 27, 0, */
	-6, 10, -6, -6, -8, -7, 31, 31, -5, 9, -5, -6, -2, -8, 31, 31,
	-4, 10, -4, -6, -2, -7, -1, -8, 31, 31, -6, 10, -4, 10, 1, 11,
	3, 12, 31, 31, 1, 11, 2, 10, 4, 9, 4, -7, 31, 31, 2, 11,
	5, 9, 5, -6, 31, 31, 3, 12, 4, 11, 6, 10, 8, 10, 6, 9,
	6, -7, 31, 31, -8, -7, -6, -7, -4, -8, -3, -9, -1, -8, 4, -7,
	6, -7};
static char c306[55] = {
	26, -10, 12,			/*, 7, 28, 1, */
	-3, 10, -2, 9, -1, 7, -1, -6, -3, -7, 31, 31, -1, 9, -2, 10,
	-1, 11, 0, 9, 0, -7, 2, -8, 31, 31, -3, 10, 0, 12, 1, 10,
	1, -6, 3, -7, 4, -7, 31, 31, -3, -7, -2, -7, 0, -8, 1, -9,
	2, -8, 4, -7};
static char c307[95] = {
	46, -10, 12,			/*, 7, 29, 2, */
	-6, 10, -4, 10, -2, 11, -1, 12, 1, 11, 4, 10, 6, 10, 31, 31,
	-2, 10, 0, 11, 31, 31, -6, 10, -4, 9, -2, 9, 0, 10, 1, 11,
	31, 31, 4, 10, 4, 2, 31, 31, 5, 9, 5, 3, 31, 31, 6, 10,
	6, 2, -1, 2, -4, 1, -6, -1, -7, -4, -7, -9, 31, 31, -7, -9,
	-4, -7, 0, -6, 4, -6, 7, -7, 31, 31, -2, -7, 3, -7, 6, -8,
	31, 31, -7, -9, -3, -8, 3, -8, 6, -9, 7, -7};
static char c308[115] = {
	56, -10, 12,			/*, 7, 30, 3, */
	-6, 10, -5, 10, -3, 11, -2, 12, 0, 11, 4, 10, 6, 10, 31, 31,
	-3, 10, -1, 11, 31, 31, -6, 10, -4, 9, -2, 9, 0, 11, 31, 31,
	4, 10, 4, 3, 31, 31, 5, 9, 5, 4, 31, 31, 6, 10, 6, 3,
	4, 3, 1, 2, -1, 1, 31, 31, -1, 2, 1, 1, 4, 0, 6, 0,
	6, -7, 31, 31, 5, -1, 5, -6, 31, 31, 4, 0, 4, -7, 31, 31,
	-7, -7, -5, -6, -3, -6, -1, -7, 0, -8, 31, 31, -3, -7, -1, -8,
	31, 31, -7, -7, -5, -7, -3, -8, -2, -9, 0, -8, 4, -7, 6, -7};
static char c309[77] = {
	37, -10, 12,			/*, 7, 31, 4, */
	3, 12, -7, 2, -7, -3, 7, -3, 8, -4, 8, -2, 7, -3, 31, 31,
	-6, 2, -6, -2, 31, 31, -5, 4, -5, -3, 31, 31, 2, 11, 2, -6,
	0, -7, 31, 31, 3, 8, 4, 10, 3, 11, 3, -7, 5, -8, 31, 31,
	3, 12, 5, 10, 4, 8, 4, -6, 6, -7, 7, -7, 31, 31, 0, -7,
	1, -7, 3, -8, 4, -9, 5, -8, 7, -7};
static char c310[107] = {
	52, -10, 12,			/*, 7, 32, 5, */
	-6, 12, -6, 2, 31, 31, -6, 12, 6, 12, 31, 31, -5, 11, 4, 11,
	31, 31, -6, 10, 3, 10, 5, 11, 6, 12, 31, 31, 4, 5, 3, 4,
	1, 3, -3, 2, -6, 2, 31, 31, 1, 3, 2, 3, 4, 2, 4, -7,
	31, 31, 3, 4, 5, 3, 5, -6, 31, 31, 4, 5, 5, 4, 7, 3,
	8, 3, 6, 2, 6, -7, 31, 31, -7, -7, -5, -6, -3, -6, -1, -7,
	0, -8, 31, 31, -3, -7, -1, -8, 31, 31, -7, -7, -5, -7, -3, -8,
	-2, -9, 0, -8, 4, -7, 6, -7};
static char c311[119] = {
	58, -10, 12,			/*, 7, 33, 6, */
	-6, 10, -6, -6, -8, -7, 31, 31, -5, 9, -5, -6, -2, -8, 31, 31,
	-4, 10, -4, -6, -2, -7, -1, -8, 31, 31, -6, 10, -4, 10, 0, 11,
	2, 12, 3, 11, 5, 10, 6, 10, 31, 31, 1, 11, 3, 10, 31, 31,
	0, 11, 2, 9, 4, 9, 6, 10, 31, 31, -4, 2, -3, 2, 1, 3,
	3, 4, 4, 5, 31, 31, 1, 3, 2, 3, 4, 2, 4, -7, 31, 31,
	3, 4, 5, 2, 5, -6, 31, 31, 4, 5, 5, 4, 7, 3, 8, 3,
	6, 2, 6, -7, 31, 31, -8, -7, -6, -7, -4, -8, -3, -9, -1, -8,
	4, -7, 6, -7};
static char c312[79] = {
	38, -10, 12,			/*, 7, 34, 7, */
	-8, 10, -5, 12, -2, 11, 3, 11, 7, 12, 31, 31, -6, 11, -3, 10,
	2, 10, 5, 11, 31, 31, -8, 10, -7, 10, -4, 9, 1, 9, 4, 10,
	7, 12, 31, 31, 7, 12, 6, 10, 4, 7, 0, 3, -2, 0, -3, -3,
	-3, -6, -2, -9, 31, 31, -1, 1, -2, -2, -2, -5, -1, -8, 31, 31,
	2, 5, 0, 2, -1, -1, -1, -4, 0, -7, -2, -9};
static char c313[143] = {
	70, -10, 12,			/*, 7, 35, 8, */
	-6, 9, -6, 3, 31, 31, -5, 8, -5, 4, 31, 31, -4, 9, -4, 3,
	31, 31, -6, 9, -4, 9, 1, 10, 3, 11, 4, 12, 31, 31, 1, 10,
	2, 10, 4, 9, 4, 3, 31, 31, 3, 11, 5, 10, 5, 4, 31, 31,
	4, 12, 5, 11, 7, 10, 8, 10, 6, 9, 6, 3, 31, 31, -6, 3,
	-4, 3, 4, 0, 6, 0, 31, 31, 6, 3, 4, 3, -4, 0, -6, 0,
	31, 31, -6, 0, -6, -6, -8, -7, 31, 31, -5, -1, -5, -6, -2, -8,
	31, 31, -4, 0, -4, -6, -2, -7, -1, -8, 31, 31, 4, 0, 4, -7,
	31, 31, 5, -1, 5, -6, 31, 31, 6, 0, 6, -7, 31, 31, -8, -7,
	-6, -7, -4, -8, -3, -9, -1, -8, 4, -7, 6, -7};
static char c314[121] = {
	59, -10, 12,			/*, 7, 36, 9, */
	-6, 10, -6, 1, -8, 0, 31, 31, -5, 9, -5, 0, -3, -1, 31, 31,
	-4, 10, -4, 1, -2, 0, -1, 0, 31, 31, -6, 10, -4, 10, 1, 11,
	3, 12, 31, 31, 1, 11, 2, 10, 4, 9, 4, -7, 31, 31, 2, 11,
	5, 9, 5, -6, 31, 31, 3, 12, 4, 11, 6, 10, 8, 10, 6, 9,
	6, -7, 31, 31, -8, 0, -7, 0, -5, -1, -4, -2, -3, -1, -1, 0,
	3, 1, 4, 1, 31, 31, -7, -7, -5, -6, -3, -6, -1, -7, 0, -8,
	31, 31, -3, -7, -1, -8, 31, 31, -7, -7, -5, -7, -3, -8, -2, -9,
	0, -8, 4, -7, 6, -7};
static char c315[25] = {
	11, -4, 6,			/*, 3, 63, ;  */
	0, 5, -1, 4, 0, 3, 1, 4, 0, 5, 31, 31, 0, -7, -1, -8,
	0, -9, 1, -8, 0, -7};
static char c316[29] = {
	13, -4, 6,			/*, 1, 63, ;  */
	0, 5, -1, 4, 0, 3, 1, 4, 0, 5, 31, 31, 0, -9, -1, -8,
	0, -7, 1, -8, 1, -10, 0, -12, -1, -13};
static char c317[9] = {
	3, -11, 13,			/*, 1, 58, <  */
	8, 9, -8, 0, 8, -9};
static char c318[13] = {
	5, -12, 12,			/*, 1, 44, =  */
	-9, 3, 9, 3, 31, 31, -9, -3, 9, -3};
static char c319[9] = {
	3, -11, 13,			/*, 1, 59, >  */
	-8, 9, 8, 0, -8, -9};
static char c320[65] = {
	31, -9, 11,			/*, 1, 51, ?  */
	-5, 8, -4, 7, -5, 6, -6, 7, -6, 8, -5, 10, -4, 11, -2, 12,
	1, 12, 4, 11, 5, 10, 6, 8, 6, 6, 5, 4, 4, 3, 0, 1,
	0, -2, 31, 31, 1, 12, 3, 11, 4, 10, 5, 8, 5, 6, 4, 4,
	2, 2, 31, 31, 0, -7, -1, -8, 0, -9, 1, -8, 0, -7};
static char c321[113] = {
	55, -13, 14,			/*, 9, 53, _  */
	5, 4, 4, 6, 2, 7, -1, 7, -3, 6, -4, 5, -5, 2, -5, -1,
	-4, -3, -2, -4, 1, -4, 3, -3, 4, -1, 31, 31, -1, 7, -3, 5,
	-4, 2, -4, -1, -3, -3, -2, -4, 31, 31, 5, 7, 4, -1, 4, -3,
	6, -4, 8, -4, 10, -2, 11, 1, 11, 3, 10, 6, 9, 8, 7, 10,
	5, 11, 2, 12, -1, 12, -4, 11, -6, 10, -8, 8, -9, 6, -10, 3,
	-10, 0, -9, -3, -8, -5, -6, -7, -4, -8, -1, -9, 2, -9, 5, -8,
	7, -7, 8, -6, 31, 31, 6, 7, 5, -1, 5, -3, 6, -4};
static char c322[121] = {
	59, -12, 14,			/*, 8, 1, A  */
	-6, 9, -4, 11, -2, 12, 0, 12, 1, 11, 8, -5, 9, -6, 11, -6,
	31, 31, -1, 11, 0, 10, 7, -6, 8, -8, 9, -7, 7, -6, 31, 31,
	-4, 11, -2, 11, -1, 10, 6, -6, 7, -8, 8, -9, 9, -9, 11, -6,
	31, 31, -6, 5, -5, 6, -3, 7, -2, 7, -1, 6, 31, 31, -2, 6,
	-2, 5, 31, 31, -5, 6, -3, 6, -2, 4, 31, 31, -11, -9, -9, -7,
	-7, -6, -4, -6, -2, -7, 31, 31, -8, -7, -4, -7, -3, -8, 31, 31,
	-11, -9, -8, -8, -5, -8, -4, -9, -2, -7, 31, 31, 0, 8, -6, -6,
	31, 31, -4, -1, 4, -1};
static char c323[221] = {
	109, -12, 15,			/*, 8, 2, B  */
	-10, 10, -8, 12, -5, 12, -3, 11, -1, 12, 31, 31, -7, 11, -4, 11,
	31, 31, -10, 10, -8, 11, -6, 10, -3, 10, -1, 12, 31, 31, -5, 7,
	-6, 6, -7, 4, -7, 3, -9, 3, -10, 2, -10, 0, -9, 1, -7, 1,
	-7, -5, 31, 31, -6, 5, -6, -3, 31, 31, -9, 2, -6, 2, 31, 31,
	-5, 7, -5, -2, -6, -4, -7, -5, 31, 31, 0, 9, -1, 8, -2, 6,
	-2, -3, 31, 31, -1, 7, -1, -1, 31, 31, 0, 9, 0, 0, -1, -2,
	-2, -3, 31, 31, 0, 9, 6, 12, 8, 11, 9, 9, 9, 7, 7, 5,
	3, 3, 31, 31, 6, 11, 8, 9, 8, 7, 31, 31, 4, 11, 6, 10,
	7, 9, 7, 6, 5, 4, 31, 31, 5, 4, 8, 2, 9, 0, 9, -6,
	31, 31, 7, 2, 8, 0, 8, -5, 31, 31, 5, 4, 6, 3, 7, 1,
	7, -6, 31, 31, -8, -9, -5, -7, -2, -6, 2, -6, 5, -7, 31, 31,
	-6, -8, -3, -7, 2, -7, 4, -8, 31, 31, -8, -9, -4, -8, 1, -8,
	3, -9, 5, -7, 7, -6, 9, -6, 31, 31, 3, 3, 3, -6, 31, 31,
	3, 0, 7, 0, 31, 31, 3, -3, 7, -3};
static char c324[139] = {
	68, -13, 13,			/*, 8, 3, C  */
	-4, 11, -6, 10, -8, 8, -9, 6, -10, 3, -10, -1, -9, -4, -8, -6,
	-5, -8, -2, -9, 1, -9, 4, -8, 6, -7, 8, -5, 9, -3, 31, 31,
	-8, 7, -9, 4, -9, -1, -7, -5, -4, -7, -1, -8, 2, -8, 5, -7,
	31, 31, -4, 11, -6, 9, -7, 7, -8, 4, -8, 0, -7, -3, -4, -6,
	-1, -7, 2, -7, 5, -6, 7, -5, 9, -3, 31, 31, -2, 8, -2, -4,
	31, 31, -1, 8, -1, -2, 31, 31, 0, 9, 0, -1, -1, -3, -2, -4,
	31, 31, -2, 8, 0, 9, 3, 12, 5, 11, 7, 11, 8, 12, 31, 31,
	2, 11, 4, 10, 6, 10, 31, 31, 1, 10, 3, 9, 5, 9, 7, 10,
	8, 12, 31, 31, 5, 9, 5, -6};
static char c325[145] = {
	71, -11, 14,			/*, 8, 4, D  */
	-9, 12, 5, 12, 7, 11, 8, 9, 8, -6, 31, 31, -7, 11, 5, 11,
	7, 9, 7, -5, 31, 31, -9, 12, -8, 11, -6, 10, 5, 10, 6, 9,
	6, -6, 31, 31, -3, 7, -4, 6, -5, 4, -5, 3, -7, 3, -8, 2,
	-8, 0, -7, 1, -5, 1, -5, -4, 31, 31, -4, 5, -4, -2, 31, 31,
	-7, 2, -4, 2, 31, 31, -3, 7, -3, -1, -4, -3, -5, -4, 31, 31,
	-9, -9, -6, -7, -3, -6, 1, -6, 4, -7, 31, 31, -7, -8, -4, -7,
	1, -7, 3, -8, 31, 31, -9, -9, -5, -8, 0, -8, 2, -9, 4, -7,
	6, -6, 8, -6, 31, 31, 0, 10, 0, -6, 31, 31, 0, 5, 2, 4,
	4, 4, 6, 5, 31, 31, 0, -1, 2, 0, 4, 0, 6, -1};
static char c326[189] = {
	93, -11, 13,			/*, 8, 5, E  */
	-9, 10, -7, 12, -5, 12, -3, 11, -1, 12, 31, 31, -6, 11, -4, 11,
	31, 31, -9, 10, -7, 11, -5, 10, -3, 10, -1, 12, 31, 31, -4, 7,
	-5, 6, -6, 4, -6, 3, -8, 3, -9, 2, -9, 0, -8, 1, -6, 1,
	-6, -5, 31, 31, -5, 5, -5, -3, 31, 31, -8, 2, -5, 2, 31, 31,
	-4, 7, -4, -2, -5, -4, -6, -5, 31, 31, -1, 5, 0, 8, 1, 10,
	2, 11, 4, 12, 6, 12, 9, 11, 31, 31, 2, 10, 4, 11, 6, 11,
	8, 10, 31, 31, 0, 8, 1, 9, 3, 10, 5, 10, 7, 9, 9, 11,
	31, 31, -1, -3, 0, 0, 1, 2, 2, 3, 4, 3, 6, 2, 31, 31,
	2, 2, 4, 2, 5, 1, 31, 31, 0, 0, 1, 1, 3, 1, 4, 0,
	6, 2, 31, 31, -7, -9, -4, -7, 0, -6, 5, -6, 9, -7, 31, 31,
	-5, -8, -2, -7, 5, -7, 8, -8, 31, 31, -7, -9, -3, -8, 4, -8,
	7, -9, 9, -7, 31, 31, -1, 5, -1, -6};
static char c327[183] = {
	90, -12, 13,			/*, 8, 6, F  */
	-8, 10, -6, 12, -3, 12, -1, 11, 1, 12, 31, 31, -5, 11, -2, 11,
	31, 31, -8, 10, -6, 11, -4, 10, -1, 10, 1, 12, 31, 31, -2, 7,
	-3, 6, -4, 4, -4, 3, -6, 3, -7, 2, -7, 0, -6, 1, -4, 1,
	-4, -4, 31, 31, -3, 5, -3, -2, 31, 31, -6, 2, -3, 2, 31, 31,
	-2, 7, -2, -1, -3, -3, -4, -4, 31, 31, 1, 8, 1, -7, 0, -8,
	-1, -8, -5, -6, -7, -6, -9, -7, -11, -9, 31, 31, 2, 8, 2, -6,
	31, 31, 2, 2, 6, 2, 31, 31, -2, -8, -3, -8, -5, -7, -8, -7,
	31, 31, 3, 9, 3, 3, 6, 3, 31, 31, 6, 1, 3, 1, 3, -5,
	2, -7, -2, -9, -4, -9, -6, -8, -8, -8, -11, -9, 31, 31, 1, 8,
	3, 9, 6, 12, 8, 11, 10, 11, 11, 12, 31, 31, 5, 11, 7, 10,
	9, 10, 31, 31, 4, 10, 6, 9, 8, 9, 10, 10, 11, 12, 31, 31,
	6, 9, 6, -5};
static char c328[175] = {
	86, -13, 14,			/*, 8, 7, G  */
	-4, 11, -6, 10, -8, 8, -9, 6, -10, 3, -10, 0, -9, -3, -8, -5,
	-6, -7, -4, -8, -1, -9, 3, -9, 6, -8, 8, -6, 9, -4, 9, -1,
	8, 1, 7, 2, 5, 3, 3, 3, 31, 31, -8, 7, -9, 4, -9, -1,
	-8, -4, 31, 31, -4, 11, -6, 9, -7, 7, -8, 4, -8, -1, -7, -4,
	-6, -6, -4, -8, 31, 31, 7, -6, 8, -5, 8, -1, 7, 1, 31, 31,
	3, -9, 5, -8, 6, -7, 7, -5, 7, -1, 6, 1, 5, 2, 3, 3,
	31, 31, -2, 8, -2, -5, 31, 31, -1, 8, -1, -3, 31, 31, 0, 9,
	0, -2, -1, -4, -2, -5, 31, 31, -2, 8, 0, 9, 3, 12, 5, 11,
	7, 11, 8, 12, 31, 31, 2, 11, 4, 10, 6, 10, 31, 31, 1, 10,
	3, 9, 5, 9, 7, 10, 8, 12, 31, 31, 7, 10, 3, 3, 3, -9,
	31, 31, 3, -1, 7, -1, 31, 31, 3, -4, 7, -4};
static char c329[225] = {
	111, -12, 14,			/*, 8, 8, H  */
	-10, 10, -8, 12, -5, 12, -3, 11, -1, 12, 31, 31, -7, 11, -4, 11,
	31, 31, -10, 10, -8, 11, -6, 10, -3, 10, -1, 12, 31, 31, -5, 7,
	-6, 6, -7, 4, -7, 3, -9, 3, -10, 2, -10, 0, -9, 1, -7, 1,
	-7, -5, 31, 31, -6, 5, -6, -3, 31, 31, -9, 2, -6, 2, 31, 31,
	-5, 7, -5, -2, -6, -4, -7, -5, 31, 31, -8, -9, -5, -7, -2, -6,
	1, -6, 3, -7, 31, 31, -6, -8, -3, -7, 0, -7, 2, -8, 31, 31,
	-8, -9, -4, -8, -1, -8, 1, -9, 3, -7, 31, 31, 0, 9, -1, 8,
	-2, 6, -2, -3, 31, 31, -1, 7, -1, -1, 31, 31, 0, 9, 0, 0,
	-1, -2, -2, -3, 31, 31, 0, 9, 2, 11, 4, 12, 6, 12, 8, 11,
	31, 31, 5, 11, 6, 11, 7, 10, 31, 31, 2, 11, 4, 11, 6, 9,
	8, 11, 31, 31, 3, 3, 5, 4, 7, 6, 8, 5, 9, 2, 9, -2,
	8, -6, 6, -9, 31, 31, 6, 5, 7, 4, 8, 2, 8, -3, 7, -6,
	31, 31, 5, 4, 6, 4, 7, 2, 7, -3, 6, -9, 31, 31, 3, 3,
	3, -7, 31, 31, 3, 0, 7, 0, 31, 31, 3, -3, 7, -3};
static char c330[135] = {
	66, -11, 12,			/*, 8, 9, I  */
	-6, 10, -4, 12, -1, 12, 2, 11, 4, 12, 31, 31, -3, 11, 1, 11,
	31, 31, -6, 10, -4, 11, -1, 10, 2, 10, 4, 12, 31, 31, 1, 7,
	0, 6, -1, 4, -1, 3, -3, 3, -4, 2, -4, 0, -3, 1, -1, 1,
	-1, -4, 31, 31, 0, 5, 0, -2, 31, 31, -3, 2, 0, 2, 31, 31,
	1, 7, 1, -1, 0, -3, -1, -4, 31, 31, 7, 10, 5, 8, 4, 5,
	4, -6, 3, -8, 1, -8, -3, -6, -5, -6, -7, -7, -9, -9, 31, 31,
	5, 7, 5, -5, 31, 31, 0, -8, -1, -8, -3, -7, -6, -7, 31, 31,
	7, 10, 6, 8, 6, -4, 5, -6, 3, -8, 1, -9, -2, -9, -4, -8,
	-7, -8, -9, -9};
static char c331[123] = {
	60, -10, 12,			/*, 8, 10, J  */
	-6, 10, -4, 12, -1, 12, 2, 11, 4, 12, 31, 31, -3, 11, 1, 11,
	31, 31, -6, 10, -4, 11, -1, 10, 2, 10, 4, 12, 31, 31, 1, 7,
	0, 6, -1, 4, -1, 3, -3, 3, -4, 2, -4, 0, -3, 1, -1, 1,
	-1, -4, 31, 31, 0, 5, 0, -2, 31, 31, -3, 2, 0, 2, 31, 31,
	1, 7, 1, -1, 0, -3, -1, -4, 31, 31, 7, 10, 5, 8, 4, 5,
	4, -6, 3, -8, 31, 31, 5, 7, 5, -5, 31, 31, 7, 10, 6, 8,
	6, -4, 5, -6, 3, -8, 0, -9, -3, -9, -6, -8, -7, -7, -8, -5,
	-8, -4, -7, -3, -6, -4, -7, -5};
static char c332[231] = {
	114, -12, 14,			/*, 8, 11, K  */
	-10, 10, -8, 12, -5, 12, -3, 11, -1, 12, 31, 31, -7, 11, -4, 11,
	31, 31, -10, 10, -8, 11, -6, 10, -3, 10, -1, 12, 31, 31, -5, 7,
	-6, 6, -7, 4, -7, 3, -9, 3, -10, 2, -10, 0, -9, 1, -7, 1,
	-7, -5, 31, 31, -6, 5, -6, -3, 31, 31, -9, 2, -6, 2, 31, 31,
	-5, 7, -5, -2, -6, -4, -7, -5, 31, 31, -8, -9, -5, -7, -2, -6,
	1, -6, 3, -7, 31, 31, -6, -8, -4, -7, 0, -7, 2, -8, 31, 31,
	-8, -9, -4, -8, -1, -8, 1, -9, 3, -7, 31, 31, 0, 9, -1, 8,
	-2, 6, -2, -3, 31, 31, -1, 7, -1, -1, 31, 31, 0, 9, 0, 0,
	-1, -2, -2, -3, 31, 31, 0, 9, 2, 11, 4, 12, 6, 12, 8, 11,
	31, 31, 5, 11, 6, 11, 7, 10, 31, 31, 2, 11, 4, 11, 6, 9,
	8, 11, 31, 31, 3, 3, 6, 6, 7, 5, 9, 4, 31, 31, 5, 5,
	7, 4, 9, 4, 31, 31, 9, 4, 7, 1, 5, -1, 3, -3, 31, 31,
	5, -1, 7, -2, 8, -6, 9, -8, 10, -8, 31, 31, 7, -4, 8, -8,
	31, 31, 5, -1, 6, -2, 7, -8, 8, -9, 9, -9, 10, -8, 31, 31,
	3, 3, 3, -7};
static char c333[171] = {
	84, -11, 13,			/*, 8, 12, L  */
	-9, 10, -7, 12, -4, 12, -2, 11, 0, 12, 31, 31, -6, 11, -3, 11,
	31, 31, -9, 10, -7, 11, -5, 10, -2, 10, 0, 12, 31, 31, -4, 7,
	-5, 6, -6, 4, -6, 3, -8, 3, -9, 2, -9, 0, -8, 1, -6, 1,
	-6, -5, 31, 31, -5, 5, -5, -3, 31, 31, -8, 2, -5, 2, 31, 31,
	-4, 7, -4, -2, -5, -4, -6, -5, 31, 31, -7, -9, -4, -7, 0, -6,
	5, -6, 9, -7, 31, 31, -5, -8, -2, -7, 5, -7, 8, -8, 31, 31,
	-7, -9, -3, -8, 4, -8, 7, -9, 9, -7, 31, 31, 1, 9, 0, 8,
	-1, 6, -1, -3, 31, 31, 0, 7, 0, -1, 31, 31, 1, 9, 1, 0,
	0, -2, -1, -3, 31, 31, 1, 9, 3, 11, 5, 12, 7, 12, 9, 11,
	31, 31, 6, 11, 7, 11, 8, 10, 31, 31, 3, 11, 5, 11, 7, 9,
	9, 11, 31, 31, 5, 11, 5, -6};
static char c334[215] = {
	106, -14, 16,			/*, 8, 13, M  */
	-6, 8, -7, 7, -8, 5, -8, 3, -10, 3, -11, 2, -11, 0, -10, 1,
	-8, 1, -8, -3, 31, 31, -7, 6, -7, -1, 31, 31, -10, 2, -7, 2,
	31, 31, -6, 8, -6, 0, -7, -2, -8, -3, 31, 31, -13, -9, -11, -7,
	-9, -6, -7, -6, -5, -7, -4, -7, -3, -6, 31, 31, -10, -7, -7, -7,
	-5, -8, 31, 31, -13, -9, -11, -8, -8, -8, -6, -9, -5, -9, -4, -8,
	-3, -6, 31, 31, -6, 8, -2, 12, 2, 8, 2, -5, 3, -7, 4, -7,
	31, 31, -2, 11, 1, 8, 1, -6, 0, -7, 1, -8, 2, -7, 1, -6,
	31, 31, -2, 2, 1, 2, 31, 31, -4, 10, -3, 10, 0, 7, 0, 3,
	-3, 3, 31, 31, -3, 1, 0, 1, 0, -6, -1, -7, 1, -9, 4, -7,
	5, -6, 31, 31, 2, 8, 6, 12, 10, 8, 10, -5, 11, -7, 12, -7,
	31, 31, 6, 11, 9, 8, 9, -6, 11, -8, 31, 31, 6, 2, 9, 2,
	31, 31, 4, 10, 5, 10, 8, 7, 8, 3, 5, 3, 31, 31, 5, 1,
	8, 1, 8, -7, 10, -9, 12, -7, 31, 31, -3, 10, -3, -6, 31, 31,
	5, 10, 5, -6};
static char c335[169] = {
	83, -12, 14,			/*, 8, 14, N  */
	-11, 9, -9, 11, -7, 12, -5, 12, -3, 11, -1, 8, 4, -3, 6, -6,
	7, -7, 31, 31, -5, 11, -3, 9, -2, 7, 4, -5, 7, -8, 31, 31,
	-9, 11, -7, 11, -5, 10, -3, 7, 2, -4, 4, -7, 5, -8, 7, -9,
	31, 31, 4, 10, 6, 9, 8, 9, 10, 10, 11, 12, 31, 31, 5, 11,
	7, 10, 9, 10, 31, 31, 4, 10, 6, 12, 8, 11, 10, 11, 11, 12,
	31, 31, -7, 3, -9, 3, -10, 2, -10, 0, -9, 1, -7, 1, 31, 31,
	-9, 2, -7, 2, 31, 31, -11, -9, -9, -7, -7, -6, -4, -6, -2, -7,
	31, 31, -8, -7, -5, -7, -3, -8, 31, 31, -11, -9, -8, -8, -5, -8,
	-4, -9, -2, -7, 31, 31, -7, 11, -7, -6, 31, 31, 7, 9, 7, -9,
	31, 31, 0, 6, 1, 5, 3, 4, 5, 4, 7, 5, 31, 31, -7, -2,
	-5, -1, -1, -1, 1, -2};
static char c336[159] = {
	78, -13, 15,			/*, 8, 15, O  */
	-4, 12, -6, 11, -8, 9, -9, 7, -10, 4, -10, 0, -9, -3, -8, -5,
	-6, -7, -4, -8, -1, -9, 1, -9, 4, -8, 6, -7, 8, -5, 9, -3,
	10, 0, 10, 4, 9, 7, 8, 9, 6, 11, 4, 12, 3, 11, 0, 9,
	-3, 8, 31, 31, -8, 8, -9, 5, -9, -1, -8, -4, 31, 31, -4, 12,
	-6, 10, -7, 8, -8, 5, -8, -1, -7, -4, -6, -6, -4, -8, 31, 31,
	8, -4, 9, -1, 9, 5, 7, 9, 6, 10, 31, 31, 4, -8, 6, -6,
	7, -4, 8, -1, 8, 5, 7, 7, 5, 10, 3, 11, 31, 31, -3, 8,
	-3, -5, 31, 31, -2, 8, -2, -3, 31, 31, -1, 8, -1, -2, -2, -4,
	-3, -5, 31, 31, 3, 11, 3, -8, 31, 31, 3, 5, 5, 4, 6, 4,
	8, 5, 31, 31, 3, -1, 5, 0, 6, 0, 8, -1};
static char c337[141] = {
	69, -10, 14,			/*, 8, 16, P  */
	-7, 12, -6, 11, -5, 9, -5, 3, -7, 3, -8, 2, -8, 0, -7, 1,
	-5, 1, -5, -7, -8, -9, -5, -8, -5, -16, -3, -14, 31, 31, -5, 10,
	-4, 8, -4, -14, 31, 31, -7, 2, -4, 2, 31, 31, -7, 12, -5, 11,
	-4, 10, -3, 8, -3, -14, 31, 31, -3, 7, 0, 9, 4, 12, 8, 8,
	8, -6, 31, 31, 4, 11, 7, 8, 7, -6, 31, 31, 2, 10, 3, 10,
	6, 7, 6, -7, 31, 31, 0, -6, 3, -6, 6, -7, 31, 31, 1, -7,
	3, -7, 5, -8, 31, 31, 0, -8, 2, -8, 4, -9, 6, -7, 8, -6,
	31, 31, 0, 9, 0, -13, 31, 31, 0, 5, 2, 4, 4, 4, 6, 5,
	31, 31, 0, -1, 2, 0, 4, 0, 6, -1};
static char c338[199] = {
	98, -13, 15,			/*, 8, 17, Q  */
	-4, 12, -6, 11, -8, 9, -9, 7, -10, 4, -10, 0, -9, -3, -8, -5,
	-6, -7, -4, -8, -2, -9, 2, -9, 4, -8, 6, -7, 8, -5, 9, -3,
	10, 0, 10, 4, 9, 7, 8, 9, 6, 11, 4, 12, 3, 11, 0, 9,
	-3, 8, 31, 31, -8, 8, -9, 5, -9, -1, -8, -4, 31, 31, -4, 12,
	-6, 10, -7, 8, -8, 5, -8, -1, -7, -4, -6, -6, -4, -8, 31, 31,
	8, -4, 9, -1, 9, 5, 7, 9, 6, 10, 31, 31, 4, -8, 6, -6,
	7, -4, 8, -1, 8, 5, 7, 7, 5, 10, 3, 11, 31, 31, -3, 8,
	-3, -5, 31, 31, -2, 8, -2, -3, 31, 31, -1, 8, -1, -2, -2, -4,
	-3, -5, 31, 31, 3, 11, 3, -8, 31, 31, 3, 5, 5, 4, 6, 4,
	8, 5, 31, 31, 3, -1, 5, 0, 6, 0, 8, -1, 31, 31, -2, -9,
	-1, -8, 0, -8, 2, -9, 6, -14, 8, -15, 9, -15, 31, 31, 2, -10,
	4, -13, 6, -15, 7, -15, 31, 31, 0, -8, 1, -9, 4, -15, 6, -16,
	8, -16, 9, -15};
static char c339[217] = {
	107, -12, 15,			/*, 8, 18, R  */
	-10, 10, -8, 12, -5, 12, -3, 11, -1, 12, 31, 31, -7, 11, -4, 11,
	31, 31, -10, 10, -8, 11, -6, 10, -3, 10, -1, 12, 31, 31, -5, 7,
	-6, 6, -7, 4, -7, 3, -9, 3, -10, 2, -10, 0, -9, 1, -7, 1,
	-7, -5, 31, 31, -6, 5, -6, -3, 31, 31, -9, 2, -6, 2, 31, 31,
	-5, 7, -5, -2, -6, -4, -7, -5, 31, 31, -8, -9, -5, -7, -2, -6,
	0, -6, 3, -7, 31, 31, -6, -8, -4, -7, 0, -7, 2, -8, 31, 31,
	-8, -9, -4, -8, -1, -8, 1, -9, 3, -7, 31, 31, 0, 9, -1, 8,
	-2, 6, -2, -3, 31, 31, -1, 7, -1, -1, 31, 31, 0, 9, 0, 0,
	-1, -2, -2, -3, 31, 31, 0, 9, 3, 11, 5, 12, 7, 11, 8, 9,
	8, 6, 7, 4, 6, 3, 2, 1, 0, 0, 31, 31, 5, 11, 6, 11,
	7, 9, 7, 5, 6, 4, 31, 31, 3, 11, 5, 10, 6, 8, 6, 5,
	5, 3, 2, 1, 31, 31, 2, 1, 4, 0, 5, -1, 8, -6, 9, -7,
	10, -7, 31, 31, 5, -2, 7, -6, 9, -8, 31, 31, 2, 1, 4, -1,
	6, -7, 8, -9, 10, -7};
static char c340[189] = {
	93, -11, 14,			/*, 8, 19, S  */
	3, 9, 2, 10, 0, 11, -3, 12, 31, 31, 4, 10, 2, 11, 31, 31,
	5, 11, 1, 12, -3, 12, -6, 11, -7, 10, -8, 8, -7, 6, -6, 5,
	-3, 4, 5, 4, 7, 3, 8, 2, 8, 0, 7, -3, 31, 31, -7, 7,
	-6, 6, -3, 5, 6, 5, 8, 4, 9, 3, 9, 1, 8, -1, 31, 31,
	-7, 10, -7, 8, -6, 7, -3, 6, 7, 6, 9, 5, 10, 3, 10, 1,
	7, -3, 3, -9, 31, 31, -9, 3, -8, 2, -6, 1, 3, 1, 4, 0,
	4, -1, 3, -3, 31, 31, -8, 1, -6, 0, 2, 0, 3, -1, 31, 31,
	-9, 3, -9, 2, -8, 0, -6, -1, 1, -1, 3, -2, 3, -3, 31, 31,
	-9, -9, -6, -7, -2, -6, 1, -6, 4, -7, 31, 31, -7, -8, -4, -7,
	0, -7, 3, -8, 31, 31, -9, -9, -5, -8, 0, -8, 3, -9, 31, 31,
	5, 11, 3, 9, 1, 6, 31, 31, 0, 4, -2, 1, 31, 31, -3, -1,
	-5, -3, -7, -4, -8, -4, -8, -3, -7, -4};
static char c341[143] = {
	70, -13, 13,			/*, 8, 20, T  */
	-8, 8, -9, 6, -10, 3, -10, -1, -9, -4, -7, -7, -5, -8, -2, -9,
	1, -9, 4, -8, 6, -7, 8, -5, 9, -3, 31, 31, -9, -1, -8, -4,
	-6, -6, -4, -7, -1, -8, 2, -8, 5, -7, 31, 31, -8, 8, -9, 5,
	-9, 1, -8, -2, -6, -5, -4, -6, -1, -7, 2, -7, 5, -6, 7, -5,
	9, -3, 31, 31, -10, 9, -9, 11, -7, 12, -3, 12, 3, 11, 7, 11,
	9, 12, 31, 31, -2, 11, 2, 10, 6, 10, 31, 31, -10, 9, -9, 10,
	-7, 11, -4, 11, 2, 9, 5, 9, 7, 10, 9, 12, 31, 31, 1, 9,
	0, 8, -2, 7, -2, -4, 31, 31, -1, 7, -1, -2, 31, 31, 0, 8,
	0, -1, -1, -3, -2, -4, 31, 31, 5, 9, 5, -6};
static char c342[179] = {
	88, -12, 14,			/*, 8, 21, U  */
	-10, 10, -8, 12, -6, 12, -3, 11, -1, 12, 31, 31, -7, 11, -4, 11,
	31, 31, -10, 10, -8, 11, -5, 10, -3, 10, -1, 12, 31, 31, -7, 8,
	-8, 6, -9, 3, -9, -1, -8, -4, -7, -6, -5, -8, -2, -9, 1, -9,
	4, -8, 6, -7, 8, -9, 10, -7, 31, 31, -8, -1, -7, -4, -4, -7,
	-1, -8, 2, -8, 31, 31, -7, 8, -8, 4, -8, 1, -7, -2, -6, -4,
	-4, -6, -1, -7, 3, -7, 6, -6, 31, 31, 3, 9, -1, 8, -2, 6,
	-2, -4, 31, 31, -1, 7, -1, -2, 31, 31, 0, 8, 0, -1, -1, -3,
	-2, -4, 31, 31, 3, 9, 5, 10, 7, 12, 8, 11, 10, 10, 8, 9,
	8, -5, 9, -7, 10, -7, 31, 31, 7, 9, 8, 10, 7, 11, 6, 10,
	7, 9, 7, -6, 9, -8, 31, 31, 5, 10, 6, 9, 6, -6, 31, 31,
	3, 9, 3, -7, 31, 31, 3, 4, 6, 4, 31, 31, 3, 0, 6, 0};
static char c343[145] = {
	71, -11, 14,			/*, 8, 22, V  */
	-8, 12, -7, 11, -6, 9, -6, 3, -8, 3, -9, 2, -9, 0, -8, 1,
	-6, 1, -6, -6, -8, -7, 31, 31, -6, 10, -5, 8, -5, -6, 31, 31,
	-8, 2, -5, 2, 31, 31, -4, -7, -1, -7, 1, -8, 31, 31, -8, 12,
	-6, 11, -5, 10, -4, 8, -4, -6, 0, -6, 3, -7, 31, 31, -8, -7,
	-5, -7, -2, -8, 0, -9, 3, -7, 6, -6, 8, -6, 31, 31, 0, 8,
	3, 9, 5, 10, 7, 12, 8, 11, 10, 10, 8, 9, 8, -6, 31, 31,
	7, 9, 8, 10, 7, 11, 6, 10, 7, 9, 7, -5, 31, 31, 5, 10,
	6, 9, 6, -6, 31, 31, 0, 8, 0, -6, 31, 31, 0, 5, 2, 4,
	4, 4, 6, 5, 31, 31, 0, -1, 2, 0, 4, 0, 6, -1};
static char c344[191] = {
	94, -14, 16,			/*, 8, 23, W  */
	-10, 12, -9, 11, -8, 9, -8, 3, -10, 3, -11, 2, -11, 0, -10, 1,
	-8, 1, -8, -6, -10, -7, 31, 31, -8, 10, -7, 8, -7, -6, 31, 31,
	-10, 2, -7, 2, 31, 31, -6, -7, -4, -7, -2, -8, 31, 31, -10, 12,
	-8, 11, -7, 10, -6, 8, -6, -6, -3, -6, -1, -7, 31, 31, -10, -7,
	-7, -7, -4, -8, -3, -9, -1, -7, 2, -6, 4, -7, 5, -9, 7, -7,
	10, -6, 31, 31, -3, 10, 0, 12, 2, 10, 2, -6, 5, -6, 7, -7,
	31, 31, 0, 11, 1, 10, 1, -6, 31, 31, -3, 10, -1, 10, 0, 9,
	0, -6, -1, -7, 31, 31, 5, -7, 6, -8, 31, 31, 5, 10, 8, 12,
	10, 10, 10, -6, 31, 31, 8, 11, 9, 10, 9, -6, 31, 31, 5, 10,
	7, 10, 8, 9, 8, -6, 7, -7, 31, 31, -3, 10, -3, -6, 31, 31,
	5, 10, 5, -6, 31, 31, -3, 4, 0, 4, 31, 31, -3, 0, 0, 0,
	31, 31, 5, 4, 8, 4, 31, 31, 5, 0, 8, 0};
static char c345[131] = {
	64, -11, 13,			/*, 8, 24, X  */
	-10, 9, -8, 11, -6, 12, -4, 12, -3, 11, 5, -7, 6, -8, 8, -8,
	31, 31, -5, 11, -4, 10, 4, -7, 5, -8, 31, 31, -8, 11, -6, 11,
	-5, 10, 3, -8, 4, -9, 6, -9, 8, -8, 10, -6, 31, 31, 5, 12,
	7, 11, 9, 11, 10, 12, 31, 31, 5, 11, 6, 10, 8, 10, 31, 31,
	4, 10, 5, 9, 7, 9, 9, 10, 10, 12, 31, 31, -10, -9, -9, -7,
	-7, -6, -5, -6, -4, -7, 31, 31, -8, -7, -6, -7, -5, -8, 31, 31,
	-10, -9, -9, -8, -7, -8, -5, -9, 31, 31, 5, 12, 1, 3, 31, 31,
	-1, 0, -5, -9, 31, 31, -6, 2, -2, 2, 31, 31, 1, 2, 6, 2};
static char c346[173] = {
	85, -11, 14,			/*, 8, 25, Y  */
	-8, 12, -7, 11, -6, 9, -6, 3, -8, 3, -9, 2, -9, 0, -8, 1,
	-6, 1, -6, -6, -8, -7, 31, 31, -6, 10, -5, 8, -5, -6, 31, 31,
	-8, 2, -5, 2, 31, 31, -4, -7, -1, -7, 1, -8, 31, 31, -8, 12,
	-6, 11, -5, 10, -4, 8, -4, -6, 0, -6, 3, -7, 31, 31, -8, -7,
	-5, -7, -2, -8, 0, -9, 3, -7, 6, -6, 31, 31, 0, 8, 3, 9,
	5, 10, 7, 12, 8, 11, 10, 10, 8, 9, 8, -12, 7, -14, 5, -16,
	3, -15, -1, -14, -6, -14, 31, 31, 7, 9, 8, 10, 7, 11, 6, 10,
	7, 9, 7, -7, 31, 31, 5, 10, 6, 9, 6, -6, 8, -9, 31, 31,
	6, -15, 4, -14, 1, -14, 31, 31, 7, -14, 4, -13, -2, -13, -6, -14,
	31, 31, 0, 8, 0, -6, 31, 31, 0, 5, 2, 4, 4, 4, 6, 5,
	31, 31, 0, -1, 2, 0, 4, 0, 6, -1};
static char c347[115] = {
	56, -11, 13,			/*, 8, 26, Z  */
	7, 11, 6, 9, 0, 3, -4, -2, -6, -5, -9, -9, 31, 31, 4, 6,
	-4, -3, 31, 31, 9, 12, 6, 8, 4, 5, 0, 0, -6, -6, -7, -8,
	31, 31, -9, 10, -7, 12, -4, 11, 3, 11, 9, 12, 31, 31, -8, 11,
	-4, 10, 1, 10, 6, 11, 31, 31, -9, 10, -5, 9, 0, 9, 5, 10,
	7, 11, 31, 31, -7, -8, -5, -7, 0, -6, 5, -6, 9, -7, 31, 31,
	-6, -8, -1, -7, 4, -7, 8, -8, 31, 31, -9, -9, -3, -8, 4, -8,
	7, -9, 9, -7, 31, 31, -6, 2, -1, 2, 31, 31, 2, 2, 6, 2};
static char c348[25] = {
	11, -7, 9,			/*, 1, 49, [  */
	-3, 16, -3, -16, 31, 31, -2, 16, -2, -16, 31, 31, -3, 16, 4, 16,
	31, 31, -3, -16, 4, -16};
static char c349[7] = {
	2, -11, 11,			/*, 1, 40, /  */
	-9, 16, 9, -16};
static char c350[25] = {
	11, -7, 9,			/*, 1, 50, ]  */
	2, 16, 2, -16, 31, 31, 3, 16, 3, -16, 31, 31, -4, 16, 3, 16,
	31, 31, -4, -16, 3, -16};
static char c351[17] = {
	7, -11, 11,			/*, 9, 28, 1, */
	-8, -2, 0, 3, 8, -2, 31, 31, -8, -2, 0, 2, 8, -2};
static char c352[7] = {
	2, -12, 12,			/*, 1, 38, -  */
	-9, -12, 9, -12};
static char c353[15] = {
	6, -6, 6,			/*, 9, 30, 3, */
	-2, 12, 3, 6, 31, 31, -2, 12, -3, 11, 3, 6};
static char c354[107] = {
	52, -8, 11,			/*, 7, 1, A  */
	-2, 0, -4, -2, -5, -4, -5, -6, -4, -8, -2, -9, 0, -7, 3, -6,
	31, 31, -5, -4, -4, -6, -3, -7, -1, -8, 31, 31, -4, -2, -4, -4,
	-3, -6, -1, -7, 0, -7, 31, 31, -4, 2, -2, 2, 1, 3, 3, 4,
	4, 5, 6, 3, 5, 2, 5, -6, 6, -7, 7, -7, 31, 31, -3, 4,
	-4, 3, -1, 3, 31, 31, 2, 3, 5, 3, 4, 4, 4, -7, 5, -8,
	31, 31, -5, 3, -3, 5, -2, 4, 0, 3, 3, 2, 3, -7, 5, -9,
	7, -7, 31, 31, -5, 3, 0, -2};
static char c355[89] = {
	43, -9, 11,			/*, 7, 2, B  */
	-6, 10, -5, 8, -5, -6, -7, -7, 31, 31, -4, 8, -5, 10, -4, 11,
	-4, -6, -1, -8, 31, 31, -6, 10, -3, 12, -3, -6, -1, -7, 0, -8,
	31, 31, -7, -7, -5, -7, -3, -8, -2, -9, 0, -8, 3, -7, 5, -7,
	31, 31, -3, 2, 0, 3, 2, 4, 3, 5, 4, 4, 6, 3, 7, 3,
	5, 2, 5, -7, 31, 31, 2, 4, 4, 3, 4, -6, 31, 31, 0, 3,
	1, 3, 3, 2, 3, -7};
static char c356[71] = {
	34, -8, 8,			/*, 7, 3, C  */
	-4, 3, -4, -6, -6, -7, -5, -7, -3, -8, -2, -9, 31, 31, -3, 3,
	-3, -7, -1, -8, 31, 31, -2, 3, -2, -6, 0, -7, 4, -5, -1, -8,
	-2, -9, 31, 31, -4, 3, 0, 4, 2, 5, 3, 4, 5, 3, 6, 3,
	31, 31, 1, 4, 2, 3, 4, 3, 31, 31, -2, 3, 0, 4, 2, 2,
	4, 2, 6, 3};
static char c357[83] = {
	40, -9, 10,			/*, 7, 4, D  */
	0, 5, -2, 4, -5, 3, -5, -6, -7, -7, 31, 31, -4, 3, -4, -6,
	-1, -8, 31, 31, 0, 5, -3, 3, -3, -6, -1, -7, 0, -8, 31, 31,
	-7, -7, -5, -7, -3, -8, -2, -9, 0, -8, 3, -7, 5, -7, 31, 31,
	-5, 10, -2, 12, -1, 9, 5, 3, 5, -7, 31, 31, -2, 9, -4, 10,
	-3, 11, -2, 9, 4, 3, 4, -6, 31, 31, -5, 10, 3, 2, 3, -7};
static char c358[65] = {
	31, -8, 8,			/*, 7, 5, E  */
	-4, 3, -4, -6, -6, -7, -5, -7, -3, -8, -2, -9, 31, 31, -3, 3,
	-3, -7, -1, -8, 31, 31, -2, 3, -2, -6, 0, -7, 4, -5, -1, -8,
	-2, -9, 31, 31, -4, 3, 0, 4, 2, 5, 5, 1, 3, 0, -2, -3,
	31, 31, 1, 4, 4, 1, 31, 31, -2, 3, 0, 4, 3, 0};
static char c359[83] = {
	40, -8, 8,			/*, 7, 6, F  */
	-4, 10, -4, -6, -6, -7, -5, -7, -3, -8, -2, -9, 31, 31, -3, 10,
	-3, -7, -1, -8, 31, 31, -2, 10, -2, -6, 0, -7, 1, -7, -1, -8,
	-2, -9, 31, 31, -4, 10, 0, 11, 2, 12, 3, 11, 5, 10, 6, 10,
	31, 31, 1, 11, 2, 10, 4, 10, 31, 31, -2, 10, 0, 11, 2, 9,
	4, 9, 6, 10, 31, 31, -7, 5, -4, 5, 31, 31, -2, 5, 1, 5};
static char c360[113] = {
	55, -9, 11,			/*, 7, 7, G  */
	-5, 3, -5, -6, -7, -7, -6, -7, -4, -8, -3, -9, -2, -8, 0, -7,
	3, -6, 31, 31, -4, 2, -4, -7, -2, -8, 31, 31, -3, 3, -3, -6,
	-1, -7, 0, -7, 31, 31, -5, 3, -3, 3, 0, 4, 2, 5, 3, 4,
	5, 3, 7, 3, 5, 2, 5, -10, 4, -13, 2, -15, 0, -16, -1, -15,
	-3, -14, -5, -14, 31, 31, 1, 4, 4, 2, 4, -10, 31, 31, 1, -15,
	-1, -14, -2, -14, 31, 31, 0, 4, 1, 3, 3, 2, 3, -8, 4, -11,
	4, -13, 31, 31, 2, -15, 1, -14, -1, -13, -3, -13, -5, -14};
static char c361[95] = {
	46, -9, 11,			/*, 7, 8, H  */
	-6, 10, -5, 8, -5, -6, -7, -7, -6, -7, -4, -8, -3, -9, 31, 31,
	-4, 8, -5, 10, -4, 11, -4, -7, -2, -8, 31, 31, -6, 10, -3, 12,
	-3, -6, -1, -7, -3, -9, 31, 31, -3, 2, 0, 3, 2, 4, 3, 5,
	4, 4, 6, 3, 7, 3, 5, 2, 5, -7, 3, -9, 2, -11, 31, 31,
	2, 4, 4, 3, 4, -7, 3, -9, 31, 31, 0, 3, 1, 3, 3, 2,
	3, -7, 2, -11, 2, -14, 3, -16, 4, -16, 2, -14};
static char c362[71] = {
	34, -5, 7,			/*, 7, 9, I  */
	0, 12, -2, 10, 0, 9, 2, 10, 0, 12, 31, 31, 0, 11, -1, 10,
	1, 10, 0, 11, 31, 31, 0, 5, -1, 4, -3, 3, -1, 2, -1, -7,
	1, -9, 3, -7, 31, 31, 0, 2, 1, 3, 0, 4, -1, 3, 0, 2,
	0, -7, 1, -8, 31, 31, 0, 5, 1, 4, 3, 3, 1, 2, 1, -6,
	2, -7, 3, -7};
static char c363[79] = {
	38, -5, 7,			/*, 7, 10, J  */
	0, 12, -2, 10, 0, 9, 2, 10, 0, 12, 31, 31, 0, 11, -1, 10,
	1, 10, 0, 11, 31, 31, 0, 5, -1, 4, -3, 3, -1, 2, -1, -7,
	1, -9, 2, -11, 31, 31, 0, 2, 1, 3, 0, 4, -1, 3, 0, 2,
	0, -7, 1, -9, 31, 31, 0, 5, 1, 4, 3, 3, 1, 2, 1, -7,
	2, -11, 2, -14, 0, -16, -2, -16, -2, -15, 0, -16};
static char c364[101] = {
	49, -9, 10,			/*, 7, 11, K  */
	-6, 10, -5, 8, -5, -6, -7, -7, -6, -7, -4, -8, -3, -9, 31, 31,
	-4, 8, -5, 10, -4, 11, -4, -7, -2, -8, 31, 31, -6, 10, -3, 12,
	-3, -6, -1, -7, -3, -9, 31, 31, -3, 2, 0, 4, 2, 5, 4, 2,
	1, 0, -3, -3, 31, 31, 1, 4, 3, 2, 31, 31, 0, 4, 2, 1,
	31, 31, 1, 0, 2, -1, 4, -6, 5, -7, 6, -7, 31, 31, 1, -1,
	2, -2, 3, -7, 4, -8, 31, 31, 0, -1, 1, -2, 2, -7, 4, -9,
	6, -7};
static char c365[45] = {
	21, -5, 7,			/*, 7, 12, L  */
	-2, 10, -1, 8, -1, -6, -3, -7, -2, -7, 0, -8, 1, -9, 31, 31,
	0, 8, -1, 10, 0, 11, 0, -7, 2, -8, 31, 31, -2, 10, 1, 12,
	1, -6, 3, -7, 4, -7, 2, -8, 1, -9};
static char c366[135] = {
	66, -13, 15,			/*, 7, 13, M  */
	-11, 3, -10, 3, -9, 2, -9, -6, -11, -7, -10, -7, -8, -8, -7, -9,
	31, 31, -9, 4, -8, 3, -8, -7, -6, -8, 31, 31, -11, 3, -9, 5,
	-7, 3, -7, -6, -5, -7, -7, -9, 31, 31, -7, 2, -4, 3, -2, 4,
	-1, 5, 1, 3, 1, -6, 3, -7, 1, -9, 31, 31, -2, 4, 0, 3,
	0, -7, 2, -8, 31, 31, -4, 3, -3, 3, -1, 2, -1, -6, -2, -7,
	0, -8, 1, -9, 31, 31, 1, 2, 4, 3, 6, 4, 7, 5, 8, 4,
	10, 3, 11, 3, 9, 2, 9, -6, 10, -7, 11, -7, 31, 31, 6, 4,
	8, 3, 8, -7, 9, -8, 31, 31, 4, 3, 5, 3, 7, 2, 7, -7,
	9, -9, 11, -7};
static char c367[91] = {
	44, -9, 11,			/*, 7, 14, N  */
	-7, 3, -6, 3, -5, 2, -5, -6, -7, -7, -6, -7, -4, -8, -3, -9,
	31, 31, -5, 4, -4, 3, -4, -7, -2, -8, 31, 31, -7, 3, -5, 5,
	-3, 3, -3, -6, -1, -7, -3, -9, 31, 31, -3, 2, 0, 3, 2, 4,
	3, 5, 4, 4, 6, 3, 7, 3, 5, 2, 5, -6, 6, -7, 7, -7,
	31, 31, 2, 4, 4, 3, 4, -7, 5, -8, 31, 31, 0, 3, 1, 3,
	3, 2, 3, -7, 5, -9, 7, -7};
static char c368[81] = {
	39, -9, 11,			/*, 7, 15, O  */
	-5, 3, -5, -6, -7, -7, 31, 31, -4, 2, -4, -6, -1, -8, 31, 31,
	-3, 3, -3, -6, -1, -7, 0, -8, 31, 31, -7, -7, -5, -7, -3, -8,
	-2, -9, 0, -8, 3, -7, 5, -7, 31, 31, -5, 3, -3, 3, 0, 4,
	2, 5, 3, 4, 5, 3, 7, 3, 5, 2, 5, -7, 31, 31, 1, 4,
	4, 2, 4, -6, 31, 31, 0, 4, 1, 3, 3, 2, 3, -7};
static char c369[109] = {
	53, -9, 11,			/*, 7, 16, P  */
	-6, 5, -5, 3, -5, -6, -7, -7, -5, -7, -5, -16, 31, 31, -5, 4,
	-4, 3, -4, -15, -3, -14, -4, -12, 31, 31, -4, -7, -3, -7, -1, -8,
	31, 31, -6, 5, -4, 4, -3, 3, -3, -6, -1, -7, 0, -8, 31, 31,
	-3, -8, -2, -9, 0, -8, 3, -7, 5, -7, 31, 31, -3, -8, -3, -12,
	-2, -14, -5, -16, 31, 31, -3, 2, 0, 3, 2, 4, 3, 5, 4, 4,
	6, 3, 7, 3, 5, 2, 5, -7, 31, 31, 2, 4, 4, 3, 4, -6,
	31, 31, 0, 3, 1, 3, 3, 2, 3, -7};
static char c370[89] = {
	43, -9, 11,			/*, 7, 17, Q  */
	-5, 3, -5, -6, -7, -7, 31, 31, -4, 2, -4, -7, -2, -8, 31, 31,
	-3, 3, -3, -6, -1, -7, 0, -7, 31, 31, -7, -7, -6, -7, -4, -8,
	-3, -9, -2, -8, 0, -7, 3, -6, 31, 31, -5, 3, -3, 3, 0, 4,
	2, 5, 3, 4, 5, 3, 7, 3, 5, 2, 5, -16, 31, 31, 1, 4,
	4, 2, 4, -15, 3, -14, 4, -12, 31, 31, 0, 4, 1, 3, 3, 2,
	3, -12, 2, -14, 5, -16};
static char c371[77] = {
	37, -8, 8,			/*, 7, 18, R  */
	-6, 3, -5, 3, -4, 2, -4, -6, -6, -7, -5, -7, -3, -8, -2, -9,
	31, 31, -5, 4, -3, 3, -3, -7, -1, -8, 31, 31, -6, 3, -4, 5,
	-2, 3, -2, -6, 0, -7, 1, -7, -1, -8, -2, -9, 31, 31, -2, 3,
	2, 5, 3, 4, 5, 3, 6, 3, 31, 31, 1, 4, 2, 3, 4, 3,
	31, 31, 0, 4, 2, 2, 4, 2, 6, 3};
static char c372[119] = {
	58, -8, 10,			/*, 7, 19, S  */
	-5, 3, -5, -1, -3, -2, 3, -2, 5, -3, 5, -7, 31, 31, -4, 3,
	-4, -1, 31, 31, 4, -3, 4, -7, 31, 31, -2, 4, -3, 3, -3, -1,
	-1, -2, 31, 31, 1, -2, 3, -3, 3, -7, 2, -8, 31, 31, -5, 3,
	-2, 4, 0, 5, 2, 4, 4, 4, 5, 5, 31, 31, -1, 4, 1, 4,
	31, 31, -2, 4, 0, 3, 2, 3, 4, 4, 31, 31, 5, -7, 2, -8,
	0, -9, -2, -8, -4, -8, -6, -9, 31, 31, 1, -8, -1, -8, 31, 31,
	2, -8, 0, -7, -3, -7, -6, -9, 31, 31, 5, 5, 4, 3, 2, 0,
	-3, -5, -6, -9};
static char c373[57] = {
	27, -5, 7,			/*, 7, 20, T  */
	-2, 10, -1, 8, -1, -6, -3, -7, -2, -7, 0, -8, 1, -9, 31, 31,
	0, 8, -1, 10, 0, 11, 0, -7, 2, -8, 31, 31, -2, 10, 1, 12,
	1, -6, 3, -7, 4, -7, 2, -8, 1, -9, 31, 31, -4, 5, -1, 5,
	31, 31, 1, 5, 4, 5};
static char c374[95] = {
	46, -9, 11,			/*, 7, 21, U  */
	-7, 3, -6, 3, -5, 2, -5, -6, -7, -7, 31, 31, -6, 4, -4, 3,
	-4, -7, -2, -8, 31, 31, -7, 3, -5, 5, -3, 3, -3, -6, -1, -7,
	0, -7, 31, 31, -7, -7, -6, -7, -4, -8, -3, -9, -2, -8, 0, -7,
	3, -6, 31, 31, 3, 5, 4, 4, 6, 3, 7, 3, 5, 2, 5, -6,
	6, -7, 7, -7, 31, 31, 2, 4, 4, 3, 4, -7, 5, -8, 31, 31,
	3, 5, 1, 3, 3, 2, 3, -7, 5, -9, 7, -7};
static char c375[73] = {
	35, -9, 11,			/*, 7, 22, V  */
	-6, 5, -5, 3, -5, -6, -2, -9, 0, -7, 3, -6, 5, -6, 31, 31,
	-5, 4, -4, 3, -4, -6, -1, -8, 31, 31, -6, 5, -4, 4, -3, 3,
	-3, -5, -2, -6, 0, -7, 31, 31, 3, 5, 4, 4, 6, 3, 7, 3,
	5, 2, 5, -6, 31, 31, 2, 4, 4, 3, 4, -5, 31, 31, 3, 5,
	1, 3, 3, 2, 3, -6};
static char c376[115] = {
	56, -13, 15,			/*, 7, 23, W  */
	-10, 5, -9, 3, -9, -6, -6, -9, -4, -7, -1, -6, 31, 31, -9, 4,
	-8, 3, -8, -6, -5, -8, 31, 31, -10, 5, -8, 4, -7, 3, -7, -5,
	-6, -6, -4, -7, 31, 31, -1, 5, -3, 3, -1, 2, -1, -6, 2, -9,
	4, -7, 7, -6, 9, -6, 31, 31, -2, 4, 0, 3, 0, -6, 3, -8,
	31, 31, -1, 5, 0, 4, 2, 3, 1, 2, 1, -5, 2, -6, 4, -7,
	31, 31, 7, 5, 8, 4, 10, 3, 11, 3, 9, 2, 9, -6, 31, 31,
	6, 4, 8, 3, 8, -5, 31, 31, 7, 5, 5, 3, 7, 2, 7, -6};
static char c377[119] = {
	58, -10, 11,			/*, 7, 24, X  */
	-7, 3, -6, 3, -4, 2, -3, 1, 1, -7, 2, -8, 4, -9, 6, -7,
	31, 31, -5, 4, -3, 3, 2, -7, 4, -8, 31, 31, -7, 3, -5, 5,
	-3, 4, -2, 3, 2, -5, 3, -6, 5, -7, 6, -7, 31, 31, 0, -1,
	3, 5, 4, 4, 6, 4, 7, 5, 31, 31, 3, 4, 4, 3, 5, 3,
	31, 31, 2, 3, 4, 2, 6, 3, 7, 5, 31, 31, -1, -3, -4, -9,
	-5, -8, -7, -8, -8, -9, 31, 31, -4, -8, -5, -7, -6, -7, 31, 31,
	-3, -7, -5, -6, -7, -7, -8, -9, 31, 31, -5, -2, -2, -2, 31, 31,
	1, -2, 4, -2};
static char c378[121] = {
	59, -9, 11,			/*, 7, 25, Y  */
	-7, 3, -6, 3, -5, 2, -5, -6, -7, -7, 31, 31, -6, 4, -4, 3,
	-4, -7, -2, -8, 31, 31, -7, 3, -5, 5, -3, 3, -3, -6, -1, -7,
	0, -7, 31, 31, -7, -7, -6, -7, -4, -8, -3, -9, -2, -8, 0, -7,
	3, -6, 31, 31, 3, 5, 4, 4, 6, 3, 7, 3, 5, 2, 5, -10,
	4, -13, 2, -15, 0, -16, -1, -15, -3, -14, -5, -14, 31, 31, 2, 4,
	4, 3, 4, -10, 31, 31, 1, -15, -1, -14, -2, -14, 31, 31, 3, 5,
	1, 3, 3, 2, 3, -8, 4, -11, 4, -13, 31, 31, 2, -15, 1, -14,
	-1, -13, -3, -13, -5, -14};
static char c379[77] = {
	37, -9, 11,			/*, 7, 26, Z  */
	6, 5, -6, -9, 31, 31, -6, 3, -4, 2, -1, 2, 2, 3, 6, 5,
	31, 31, -5, 4, -3, 3, 1, 3, 31, 31, -6, 3, -4, 5, -2, 4,
	2, 4, 6, 5, 31, 31, -6, -9, -2, -7, 1, -6, 4, -6, 6, -7,
	31, 31, -1, -7, 3, -7, 5, -8, 31, 31, -6, -9, -2, -8, 2, -8,
	4, -9, 6, -7, 31, 31, -4, -2, 4, -2};
static char c380[57] = {
	27, -7, 9,			/*, 3, 49, [  */
	2, 16, -1, 13, -2, 10, -2, 8, -1, 5, 2, 2, 31, 31, 0, 14,
	-1, 11, -1, 7, 0, 4, 31, 31, 2, 2, -1, 0, 2, -2, 31, 31,
	2, -2, -1, -5, -2, -8, -2, -10, -1, -13, 2, -16, 31, 31, 0, -4,
	-1, -7, -1, -11, 0, -14};
static char c381[7] = {
	2, -4, 4,			/*, 9, 14, N  */
	0, 16, 0, -16};
static char c382[57] = {
	27, -7, 9,			/*, 3, 50, ]  */
	-2, 16, 1, 13, 2, 10, 2, 8, 1, 5, -2, 2, 31, 31, 0, 14,
	1, 11, 1, 7, 0, 4, 31, 31, -2, 2, 1, 0, -2, -2, 31, 31,
	-2, -2, 1, -5, 2, -8, 2, -10, 1, -13, -2, -16, 31, 31, 0, -4,
	1, -7, 1, -11, 0, -14};
static char c383[49] = {
	23, -12, 14,			/*, 3, 59, >  */
	-9, -3, -9, -1, -8, 2, -6, 3, -4, 3, -2, 2, 2, -1, 4, -2,
	6, -2, 8, -1, 9, 1, 31, 31, -9, -1, -8, 1, -6, 2, -4, 2,
	-2, 1, 2, -2, 4, -3, 6, -3, 8, -2, 9, 1, 9, 3};
static char c384[7] = {
	2, -12, 14,			/*, 3, 38, -  */
	-9, -12, 9, -12};

static char *p[384] = { 
	c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, c11, c12,
	c13, c14, c15, c16, c17, c18, c19, c20, c21, c22, c23, c24,
	c25, c26, c27, c28, c29, c30, c31, c32, c33, c34, c35, c36,
	c37, c38, c39, c40, c41, c42, c43, c44, c45, c46, c47, c48,
	c49, c50, c51, c52, c53, c54, c55, c56, c57, c58, c59, c60,
	c61, c62, c63, c64, c65, c66, c67, c68, c69, c70, c71, c72,
	c73, c74, c75, c76, c77, c78, c79, c80, c81, c82, c83, c84,
	c85, c86, c87, c88, c89, c90, c91, c92, c93, c94, c95, c96,
	c97, c98, c99, c100,c101,c102,c103,c104,c105,c106,c107,c108,
	c109,c110,c111,c112,c113,c114,c115,c116,c117,c118,c119,c120,
	c121,c122,c123,c124,c125,c126,c127,c128,c129,c130,c131,c132,
	c133,c134,c135,c136,c137,c138,c139,c140,c141,c142,c143,c144,
	c145,c146,c147,c148,c149,c150,c151,c152,c153,c154,c155,c156,
	c157,c158,c159,c160,c161,c162,c163,c164,c165,c166,c167,c168,
	c169,c170,c171,c172,c173,c174,c175,c176,c177,c178,c179,c180,
	c181,c182,c183,c184,c185,c186,c187,c188,c189,c190,c191,c192,
	c193,c194,c195,c196,c197,c198,c199,c200,c201,c202,c203,c204,
	c205,c206,c207,c208,c209,c210,c211,c212,c213,c214,c215,c216,
	c217,c218,c219,c220,c221,c222,c223,c224,c225,c226,c227,c228,
	c229,c230,c231,c232,c233,c234,c235,c236,c237,c238,c239,c240,
	c241,c242,c243,c244,c245,c246,c247,c248,c249,c250,c251,c252,
	c253,c254,c255,c256,c257,c258,c259,c260,c261,c262,c263,c264,
	c265,c266,c267,c268,c269,c270,c271,c272,c273,c274,c275,c276,
	c277,c278,c279,c280,c281,c282,c283,c284,c285,c286,c287,c288,
	c289,c290,c291,c292,c293,c294,c295,c296,c297,c298,c299,c300,
	c301,c302,c303,c304,c305,c306,c307,c308,c309,c310,c311,c312,
	c313,c314,c315,c316,c317,c318,c319,c320,c321,c322,c323,c324,
	c325,c326,c327,c328,c329,c330,c331,c332,c333,c334,c335,c336,
	c337,c338,c339,c340,c341,c342,c343,c344,c345,c346,c347,c348,
	c349,c350,c351,c352,c353,c354,c355,c356,c357,c358,c359,c360,
	c361,c362,c363,c364,c365,c366,c367,c368,c369,c370,c371,c372,
	c373,c374,c375,c376,c377,c378,c379,c380,c381,c382,c383,c384};
/*--------------------------*/
	i = char_per_font * font + (ch-32);
	c = error_char;
	if (i >= 0 && i <383) c = p[i];
	*npts = ( *c++) << 1;		/* convert pt count to coord count*/
	*min = *c++;			/* extent of char, in char coords*/
	*max = *c++;
	for (i=0; i<*npts; i++) *pts++ = *c++;
}

